                %title  "Matopas 2: Kerttvt esineet"
		%subttl "(C) Copyright 1994-1999 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1999 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "MoveZX.mac"
                include "Rnd.mac"
                include "Lot.mac"
                include "Double.mac"

                include "Matopas2.typ"

		include "Esineet.inc"
                include "Tilanne.inc"
                include "Piirto.inc"
                include "Liikkeet.inc"  ; Suunnat#
                include "Bkg.inc"
                include "Ominais.inc"
                include "Sfx.inc"
                include "Ohjelma.inc"   ; RandSeed

                include "bc_nimet.inc"
                include "fx_nimet.inc"

		include "B_Mitta.inc"

		include "Alloc.inc"



SUORA_NUKE      =       FALSE

RAAMI_VALITTU   =       87h     ; vasemman yl-
RAAMI_NORMAALI  =       2Fh     ; nurkan vrit



                macro   ITEM    bc:req, rutiini:rest
                org     Kyttrutiinit + (size _PROC)*bc
                _PROC   rutiini
                endm



                udataseg

RaaminSiirros   dw      ?
LuvunSiirros    dw      ?

Nuke_Eteen	dw	?
Nuke_ParasOs	dw	?
Nuke_Varatut    db      128 dup (?)



		const

; Huom! Nm on mys hardcoodattu Piirr[Yhden]Esineet-rutiineihin!

; Yksinpelin osoitteet
RaaminOfs1	dw	 13 + 165*320,	 25 + 165*320,	\
			 13 + 175*320,	 25 + 175*320,	\
                         13 + 185*320,   25 + 185*320
LuvunOfs1       dw        5 + 165*320,   38 + 165*320,  \ raamin ja luvun
                          5 + 175*320,   38 + 175*320,  \ osoitteet lhekkin
                          5 + 185*320,   38 + 185*320

; Kaksinpelin osoitteet, pelaaja 0
RaaminOfs2_0	dw	173 + 165*320,	185 + 165*320,	\
			173 + 175*320,	185 + 175*320,	\
                        173 + 185*320,  185 + 185*320
LuvunOfs2_0     dw      165 + 165*320,  177 + 165*320,  \
                        165 + 175*320,  177 + 175*320,  \
                        165 + 185*320,  177 + 185*320

; Kaksinpelin osoitteet, pelaaja 1
RaaminOfs2_1	dw	 12 + 165*320,	 24 + 165*320,	\
                         12 + 175*320,   24 + 175*320,  \
                         12 + 185*320,   24 + 185*320
LuvunOfs2_1     dw        4 + 165*320,   37 + 165*320,  \
                          4 + 175*320,   37 + 175*320,  \
                          4 + 185*320,   37 + 185*320



                dataseg

Rutiini0        _PROC   EsKonu
Rutiini1        _PROC   EsPaineraketti
Valittu0        _ESINE  Esineet0
Valittu1        _ESINE  Esineet1

; Pelaajien esineet -- aivan perkkin!
Esineet0	ESINE	6 dup (<>)
Esineet1	ESINE	6 dup (<>)

; Tytetn esinetiedot
                org     Esineet0
                ESINE   <bcKONARI,       12>, \
                        <bcSINKO,        23>, \
                        <bcNUKE,         34>, \
                        <bcLASERASE,     45>, \
                        <bcLIEKINHEITIN, 56>, \
                        <bcTYKKI,        67>

                org     Esineet1
                ESINE   <bcPOMMI,        98>, \
                        <bcLEVASE,      87>, \
                        <bcKONARI,       76>, \
                        <bcSINKO,        65>, \
                        <bcTYKKI,        54>, \
                        <bcLIEKINHEITIN, 43>



                const

Kyttrutiinit  _PROC   256 dup (EsTyhj)
                ITEM    bcILMA,         EsVeto
                ITEM    bcPILLERI,      EsPilleri
                ITEM    bcMIINAASE,     EsTyhj
                ITEM    bcSINKO,        EsRaketti
                ITEM    bcPAINESINKO,   EsPaineraketti
                ITEM    bcLASERASE,     EsLaser
                ITEM    bcLIEKINHEITIN, EsRoihutin
                ITEM    bcPISTOOLI,     EsTyhj
                ITEM    bcPOMMI,        EsPommi
                ITEM    bcRADIOLHETIN, EsTyhj
                ITEM    bcKONARI,       EsKonu
                ITEM    bcLEVASE,      EsLevase
                ITEM    bcSPRAY,        EsTyhj
                ITEM    bcNUKE,         EsNuke
                ITEM    bcTYKKI,        EsTykki
                ITEM    bcPOMMIASE,     EsPommi
                ITEM    bcAVAIN,        5 dup (EsTyhj)
                ITEM    bcTELAKETJU,    EsTyhj
                ITEM    bcJOUSIPYSSY,   EsTyhj
                ITEM    bcPUUKKO,       EsTyhj
                org     Kyttrutiinit + 256*size Kyttrutiinit



                codeseg

;ͻ
; proc Esineet_Yksinpeliksi						       
; Alustaa Esineet-moduulin yksinpeli varten.				       
;ͼ
                proc    Esineet_Yksinpeliksi
		mov	AX, offset RaaminOfs1
		mov	BX, offset LuvunOfs1
		sub	AX, offset Esineet0
		sub	BX, offset Esineet0
		mov	[RaaminSiirros], AX
		mov	[LuvunSiirros], BX
		ret
		endp	Esineet_Yksinpeliksi

;ͻ
; proc Esineet_Kaksinpeliksi						       
; Alustaa Esineet-moduulin kaksinpeli varten. 			       
;ͼ
                proc    Esineet_Kaksinpeliksi
		mov	AX, offset RaaminOfs2_0
		mov	BX, offset LuvunOfs2_0
		sub	AX, offset Esineet0
		sub	BX, offset Esineet0
		mov	[RaaminSiirros], AX
		mov	[LuvunSiirros], BX
                ret
                endp    Esineet_Kaksinpeliksi

;ͻ
; proc Kuluta                                                                 
; Vhent esineen mr ja lopulta poistaa sen.                             
; Sisn: SI=esineen osoite                                                   
;ͼ
                proc    Kuluta  near
                PUSHLOT AX BX CX SI DI
                 mov     AL, [(ESINE SI).Mr]
                 dec     AL
                 mov     [(ESINE SI).Mr], AL
                 add     SI, [LuvunSiirros]
                 mov     DI, [SI]
                 call    PiirrLuku
                POPLOT  DI SI CX BX AX
                ret
                endp    ;*

;ͻ
; Rekisterit esinerutiineihin tultaessa:                                      
;  BP = pelaajan numero kertaa kaksi (tai nelj jos @CodeSize ne 0)           
;  SI = valitun esineen osoite                                                
;  DI = ukon osoite, palauta ennallaan                                        
;  CX = pelikentt jljell, palauta ennallaan                               
;  AX, BX, DX: saa kytt                                                    
;ͼ

                proc    EsTyhj
                ret
                endp    EsTyhj

                proc    EsVeto
                MOVEZX  BX, [byte DI+1]
                DOUBLE  BX
                mov     BX, [Suunnat+BX]        ; katsotaan ensin edest
                MOVEZX  SI, [DI+BX] ; SI saa tss tuhoutua - tyhj ei kulu
                test    [Ominaisuudet1 + SI], om1TYNT ; eli mys veto
                jz      @@Ret   ; ei voi vet
                neg     BX      ; sitten katsotaan takaa
                cmp     [byte DI+BX], bcILMA
                jne     @@Ret   ; ei tilaa
                mov     AX, [DI]
                push    BX
                 call    Fiksusti    ; siirretn ukko
                pop     BX
                neg     BX
                mov     AX, [DI+BX]
                push    BX
                 xor     BX, BX
                 call    Sijoita     ; siirretn esine - Fiksusti olisi turha
                pop     BX
                xor     AX, AX
                call    Fiksusti     ; pyyhitn esine
@@Ret:          ret
                endp    EsVeto

                proc    EsPilleri
if @CodeSize
                shr     BP, 1
endif
                shr     BP, 1   ; nyt BP on 0 tai 1
                add     [MadonPit0+BP], 10
                add     [Matoaika0+BP], 10
                ret
                endp    EsPilleri

                proc    EsPommi
                cmp     [(ESINE SI).Mr], 0
                je      @@Ret
                MOVEZX  BX, [byte DI+1]
                DOUBLE  BX
                mov     BX, [Suunnat+BX]
                cmp     [byte DI+BX], bcILMA
                jne     @@Ret
                call    Kuluta
                mov     AX, bcPOMMIPALO+0F00h
                call    Sijoita
@@Ret:          ret
                endp    EsPommi

                proc    EsRaketti
                MOVEZX  BX, [byte DI+1]
                mov     DX, fxKONARI
                lea     AX, [BX+bcRAKETTI4]
Ammus:          DOUBLE  BX
                mov     BX, [Suunnat+BX]
                cmp     [byte DI+BX], bcILMA
                jne     @@Ret
                push    BX
                 SFX     DX
                pop     BX
                call    Fiksusti
@@Ret:          ret
                endp    EsRaketti

                proc    EsPaineraketti
                MOVEZX  BX, [byte DI+1]
                mov     DX, fxKONARI
                lea     AX, [BX+bcPAINERAK4]
                jmp     Ammus
                endp    EsPaineraketti

                proc    EsLevase
                mov     AX, bcLEV1 + 7C00h
                MOVEZX  BX, [byte DI+1]
                mov     DX, fxLEV
                add     AH, BL
                jmp     Ammus
                endp    EsLevase

                proc    EsRoihutin
                MOVEZX  BX, [byte DI+1]
                mov     AH, BL
                mov     AL, bcPALO
                inc     AH
		DOUBLE	BX
                mov     BX, [Suunnat+BX]
                MOVEZX  SI, [DI+BX]
                test    [Ominaisuudet2+SI],om2HARVA
                jz      @@Ret
                call    Fiksusti
@@Ret:          ret
                endp    EsRoihutin

                proc    EsLaser
                MOVEZX  BX, [byte DI+1]
                mov     DX, fxLASER
                lea     AX, [BX+bcLASER4]
                jmp     Ammus
                endp    EsLaser

                proc    EsTykki
                MOVEZX  BX, [byte DI+1]
                mov     DX, fxOHJUS
                lea     AX, [BX+bcTYKINAMMUS4]
                jmp     Ammus
                endp    EsTykki

		proc	EsNuke
                push    CX DI ES SI
	; Etsitn vapaa extrabittiarvo. Taulukko "Nuke_Varatut" ensin
	; tyhjennetn, ja sitten siihen merkitn jokainen lydetty ohjus
	; ykksell.
		    lea     DI, [Nuke_Varatut]
                    xor     AX, AX
                    push    DS
                     mov     CX, 128/2
                    pop     ES
		    assume  ES:@data
                    rep     stosw
                    lea     SI, [Pelikentt]
                    mov     CX, LEVEYS*KORKEUS
                    xor     BX, BX
@@EtsintLoop:      lodsw
                    sub     AL, bcOHJUS8
                    cmp     AL, 8
                    jnb     @@EtsintSeuraava
                    mov     BL, AH
                    and     BL, 7Fh
		    mov     [Nuke_Varatut+BX], 1
@@EtsintSeuraava:  loop    @@EtsintLoop
	; Sitten tyhjennetn kyttmttmt kohdat mys Kohdeosoitteet-
	; ja Kohderutiinit-taulukoista ja etsitn samalla ensimminen
	; kyttmtn indeksi BP:hen.
	; Tyn yksinkertaistamiseksi aloitetaan lopusta. Ja silmukassa
	; BP on kaksinkertainen.
		    std
		    mov     BP, -1	; tarkoittaa ettei viel ole lytynyt
		    xor     AX, AX	; etsitn tyhj paikkaa
		    lea     DI, [Nuke_Varatut+127]
		    mov     BX, 128*2	; tuplattu laskuri
@@TyhjennysLoop:    scasb
		    jnz     @@EiVapaa
	; Tm indeksi on vapaa.
		    mov     [Kohdeosoitteet+BX-2], AX ;=0
		    mov     [Kohderutiinit+BX-2], AX ;=0
		    lea     BP, [BX-2]
@@EiVapaa:	    dec     BX
		    dec     BX
		    jnz     @@TyhjennysLoop
		    cld 	;hui! sken unohtui!
	; Lytyik?
		    cmp     BP, -1
                pop     SI ES DI CX
		assume	ES:nothing ; pitisikhn mritell segmentti VGA?
		jne	@@VapaaIndeksi	; cmp...
		ret	; pieleen meni
@@VapaaIndeksi: shr	BP, 1			; BP = vapaa indeksi!!
		MOVEZX	BX, [byte DI+1] ; ukon extrabitit = suunta
                push    BX
		 mov	 AX, BP 		; mys AX = vapaa indeksi
                 DOUBLE  BX
                 mov     AH, AL
                 mov     AL, BL
                 add     AL, bcOHJUS8           ; AX = ohjuspalikka
                 push    AX
	; Nyt pstn itse asiaan eli hakeutumiseen. Tutkitaan ensin, onko
	; suoraan edesspin mitn kohteeksi kelpaavaa.
                  mov     AX, [Suunnat+BX]
                  push    DI
@@SuoraanLoop:	   add	   DI, AX
                   MOVEZX  BX, [DI]
                   test    [Ominaisuudet2+BX], om2HARVA or om2ELV
		   jz	   @@SuoraanSein
                   test    [Ominaisuudet2+BX], om2ELV
		   jz	   @@SuoraanLoop
                   DOUBLE  BP           ; kerrotaan vapaa indeksi kahdella
                   mov     [Kohdeosoitteet+BP], DI
                   DOUBLE  BX
                   mov     AX, [Hyppytaulukko+BX] ; luetaan rutiini
                   mov     [Kohderutiinit+BP], AX
                  pop     DI
                pop     AX BX
                mov     DX, fxOHJUS
		jmp	Ammus
@@SuoraanSein:   pop	  DI
		pop	AX BX
        ; Edess ei ollut mitn kelvollista. Siisp tutkitaan 90 sektori.
	;   BX = ukon suunta
	;   BP = vapaa indeksi
	;   SI = valitun esineen (ohjustykin) osoite
	;   DI = ukon osoite, jtettv ennalleen
	;   CX = pelikentt jljell, jtettv ennalleen
	;   AX = ohjuspalikka
	;   DX = vapaa
	; Ensin tallennetaan rekistereit.
		push	CX DI SI AX BX
	; Sitten erotellaan ukon osoitteesta koordinaatit.
	errif LEVEYS ne 32 <Ai ai! LEVEYS ne 32 -> sait tit.>
		     mov     AX, DI
		     sub     AX, offset Pelikentt  ; AX: 00000YYY YYXXXXX0
		     shl     AX, 2		    ; AX: 000YYYYY XXXXX000
		     shr     AL, 3		    ; AX: 000YYYYY 000XXXXX
	; Seuraavaksi tarkistetaan ukon suunta. Jokaiselle on oma ptk, joka
	; laskee, paljonko eri suuntiin on tilaa.
	; Tilan laskennassa kelpuutetaan mys reunus.
		     and     BX, 3	 ; varmuuden vuoksi
		     DOUBLE  BX
		     call    [@@Katserutiinit+BX]   ; CH=eteen, AL=vas, AH=oik
	; Sitten lhdetn tutkimaan maastoa tss jrjestyksess:
	;	     v			Suora linja tutkitaan siis
	;	3   0/2   1		kahteen kertaan. Mutta ei se
	;  9	8   4/7   5    6	paljon hidasta.
		     push    BP
		      test    CH, CH	; ukko kentn reunaa vasten?
		      jz      @@EiSitten
		      mov     SI, [Suunnat+BX]
		      mov     [Nuke_Eteen], SI
		      add     SI, DI	; ei thdt itse
		      mov     BP, [Suunnat+3*2+BX]
		      mov     BX, AX
		      mov     DX, 0FFFFh
		      xor     AX, AX
		      mov     CL, 1
	;   DX = pienin sakko
	;   BP = osoitteen kasvatus
	;   AX = alkusakko
	;   SI = linjaosoite
	;   BL = tutkitaan vasemmalle
	;   BH = tutkitaan oikealle
	;   CL = raja paljonko katsotaan sivulle
	;   CH = vhenev laskuri paljonko mennn eteenpin
	;   [Nuke_ParasOs] = paras osoite
@@VyhykeLoop:	      add     SI, [Nuke_Eteen]
		      inc     CL
		      push    CX BX
	; Rajoitetaan matkat.
			cmp	BL, CL
			jna	@@VasMahtuu
			mov	BL, CL
@@VasMahtuu:		cmp	BH, CL
			jna	@@OikMahtuu
			mov	BH, CL
@@OikMahtuu:
	; Katsotaan vasemmalle.
			MOVEZX	CX, BL	; sallittu matka
			push	BX
			 call	 @@Sivulle
			pop	BX
			cmp	AX, DX	; vielk kannattaa jatkaa?
			jnb	@@Loppu
	; Sitten oikealle.
			neg	BP	; osoitteen kasvatus
			MOVEZX	CX, BH	; sallittu matka
			call	@@Sivulle
			neg	BP
			cmp	AX, DX	; vielk kannattaa jatkaa?
			jnb	@@Loppu
		      pop     BX CX
		      add     AL, CL	; alkusakko kasvaa
		      adc     AH, 0
		      dec     CH
		      jnz     @@VyhykeLoop
		      jmp     @@Saalis
	; Eponnistumiskoodi on rumasti tss vliss.
@@EiSitten:	pop	BP BX AX SI DI CX
                ret
@@Loppu:              pop     BX CX
	; Nyt tutkitaan, saatiinko saalista.
@@Saalis:	      cmp     DX, 0FFFFh	; paras sakko
		      je      @@EiSitten
	; Kyll maar!
                     pop     BP ; vapaa indeksi
		     DOUBLE  BP 	; kerrotaan vapaa indeksi kahdella
		     mov     DI, [Nuke_ParasOs]
		     mov     [Kohdeosoitteet+BP], DI
		     MOVEZX  BX, [DI]
		     DOUBLE  BX
		     mov     AX, [Hyppytaulukko+BX] ; luetaan rutiini
		     mov     [Kohderutiinit+BP], AX
		pop	BX AX SI DI CX
                mov     DX, fxOHJUS
		jmp	Ammus
                ret
		const
@@Katserutiinit dw	@@KatseOikealle, @@KatseAlas, \
			@@KatseVasemmalle, @@KatseYls
		codeseg
	; Sisn:
	;   AH = Y, AL = X
	; Ulos:
	;   CH = tila edess
        ;   AL = tila vasemmalla
	;   AH = tila oikealla
	;   muut ennallaan
		proc	@@KatseOikealle near
		mov	CH, LEVEYS-1
		sub	CH, AL		; edess     = LEVEYS-1-x
		mov	AL, AH		; vasemmalla = y
		mov	AH, KORKEUS-1
		sub	AH, AL		; oikealla   = KORKEUS-1-y
		ret
		endp   ;@@KatseOikealle
		proc	@@KatseAlas	near
		mov	CH, KORKEUS-1
		sub	CH, AH		; edess     = KORKEUS-1-y
		mov	AH, AL		; oikealla   = x
		mov	AL, LEVEYS-1
		sub	AL, AH		; vasemmalla = LEVEYS-1-x
		ret
		endp   ;@@KatseAlas
		proc	@@KatseVasemmalle	near
		mov	CH, AL		; edess     = x
		mov	AL, KORKEUS-1
		sub	AL, AH		; vasemmalla = KORKEUS-1-y
		ret			; oikealla   = y
		endp   ;@@KatseVasemmalle
		proc	@@KatseYls	near
		mov	CH, AH		; edess     = y
		mov	AH, LEVEYS-1
		sub	AH, AL		; oikealla   = LEVEYS-1-x
		ret			; vasemmalla = x
		endp   ;@@KatseYls
	; Tm alialiohjelma astelee katselinjalta sivullepin.
	; Sisn:
	;   SI = ensimminen tutkittava osoite
	;   BP = osoitteen kasvatus
        ;   CX = laskuri montako askelta saadaan ottaa
	;   DX = pienin sakko
	;   AX = alkusakko
	;   [Nuke_ParasOs] = paras osoite
	; Ulos:
	;   BP = ennallaan (osoitteen kasvatus)
        ;   CX = ennallaan (montako askelta)
	;   SI = ennallaan (lhtosoite)
	;   AX = ennallaan (alkusakko)
	;   DX = pienin sakko
        ;   [Nuke_ParasOs] = paras osoite
	;   BX, DI sekaisin
		proc	@@Sivulle	near
	; Ensin tarkistetaan litilanne.
		jcxz	@@Ret
	; Sitten asetellaan rekisterit.
		push	AX SI CX
		   xor	   DI, DI
		   xor	   BX, BX
	; Silmukassa:
	;   SI = tutkittava osoite
	;   BX = temppi
	;   AX = tutkittava sakko
	;   DX = pienin sakko
	;   DI = sakon kasvatus
	;   BP = osoitteen kasvatus
	;   CX = laskuri montako askelta viel saadaan ottaa
@@AskelLoop:	   mov	   BL, [SI]    ;BH=0
		   test    [Ominaisuudet2+BX], om2ELV
		   jnz	   @@Elv
@@MietiViel:	   add	   AX, DI      ; kasvatetaan sakkoa
		   add	   SI, BP
		   cmp	   AX, DX      ; jos sakko ei en ole pienint
		   inc	   DI  ; (inc ei kajoa carryyn)
		   jnb	   @@Huti      ; pienempi, on aika lopettaa
		   loop    @@AskelLoop
	; Kohdetta ei lytynyt. Palautetaan rekisterit ja hivytn.
@@Huti: 	pop	CX SI AX
@@Ret:		ret
	; Jotakin elv lytyi. Sakko on pienempi kuin edellinen pienin,
	; koska muuten silmukasta olisi jo poistuttu.
@@Elv:	    push    CX AX
	; Nyt tulee uutuus. Tutkitaan, onko thn kohteeseen jo tulossa
	; ohjuksia. Jos on, rtkistn jokaisesta satanen sakkoa.
	; BX: ei tarvinnut pushata. Riitt, ett se nollataan palattaessa.
		      lea     BX, [Kohdeosoitteet]
		      mov     CX, 128
@@KumppaniLoop:       cmp     [BX], SI	; sama mrnp?
		      jne     @@EriKohde
		      add     AX, 100	; sakotetaan!
@@EriKohde:	      inc     BX
		      inc     BX
		      loop    @@KumppaniLoop
	; Onko lyt thnastisista paras?
		      cmp     AX, DX
		      jnb     @@EiParas
		      mov     DX, AX		    ; sakko
		      mov     [Nuke_ParasOs], SI    ; osoite
@@EiParas:	    pop     AX CX
		    xor     BX, BX	; Silmukassa BH:n pit olla 0
		    jmp     @@MietiViel
		endp   ;@@Sivulle
                endp    EsNuke

                proc    EsKonu
                MOVEZX  BX, [byte DI+1]
                DOUBLE  BX
                mov     SI, DI  ;BP,BX,DX,SI saa mys kytt
                mov     AX, [Suunnat+BX]
        ;AX.........Suunta  (alas = 64)
        ;SI.........Osoitin kentlle
                add     SI, AX
                MOVEZX  BX, [byte SI]
                test    [Ominaisuudet2+BX], om2HARVA
                jz      @@Ret   ; jos oli este heti ukon edess
                SFX     fxKONARI
                xor     BH, BH
@@KonuLoop:     add     SI, AX
                mov     BL, [SI] ; BH=0
                test    [Ominaisuudet2+BX], om2HARVA
                jnz     @@KonuLoop ; jos oli harva niin etsitn lis
                test    [Ominaisuudet2+BX], om2POMMI or om2ELV
                jnz     @@Elv
                test    [Ominaisuudet1+BX], om1TYNT
                jz      @@Viereen
        ; Tynnetnk?
                mov     BX, AX
                cmp     [byte SI+BX], bcILMA
                jne     @@EiTyonnet
                mov     AX, [SI]
                push    SI BX   ; SI=osoite, BX=suunta
                  sub     SI, DI
                  push    SI
                   add     BX, SI
                   call    Fiksusti  ; siirretn uuteen paikkaan
                  pop     BX
                  xor     AX, AX
                  call    Fiksusti   ; pyyhitn entinen
                pop     BX SI
                xor     AH, AH
                jmp     @@Tynnetty ; nyt on oltava BX=suunta, AH=0
@@EiTyonnet:   xor     BH, BH  ;( - optimointi vie hulluuteen...
@@Viereen:      sub     SI, AX  ; jos ei elv niin plyt viereen, ei plle
@@Elv:       xchg    BX, AX  ; BX := suunta, AH := 0
@@Tynnetty:    push    SI
                 mov     AL, [DI+1] ; tutkitaan ukon suunta extrabiteist
                 xor     AL, 2  ; knnetn 180
                 add     AL, bcLIESKA4
                 call    Fiksusti ; lieska
                pop     BX
                push    BX
                 MOVEZX  BX, [byte BX]
                 mov    AL, bcPLY
                 mov    AH, [Raatotaulukko+BX]
                pop     BX
                sub     BX, DI
                call    Rjyt ; ply joka muuttuu myhemmin raadoksi
@@Ret:          ret
                endp    EsKonu

                proc    PiirrEsineet
                cmp     [Pelaajia], 1
                ja      @@Kaksinpeli
        ; Yksinpeli, pelaaja 0.
                mov     DI, 14 + 320*166
		mov	SI, offset RaaminOfs1
		sub	SI, offset Esineet0
                lea     BP, [Esineet0]
                mov     BX, [Valittu0]
                jmp     PiirrYhdenEsineet ;yhtlailla near tai far kuin tmkin
        ; Kaksinpeli, pelaaja 0.
@@Kaksinpeli:   mov     DI, 174 + 320*166
		mov	SI, offset RaaminOfs2_0
		sub	SI, offset Esineet0
                lea     BP, [Esineet0]
                mov     BX, [Valittu0]
		call	PiirrYhdenEsineet
        ; Kaksinpeli, pelaaja 1.
                mov     DI, 13 + 320*166
		mov	SI, offset RaaminOfs2_1
		sub	SI, offset Esineet1
                lea     BP, [Esineet1]
                mov     BX, [Valittu1]
                endp    PiirrEsineet ; PiirrYhdenEsineet heti pern!

		proc	PiirrYhdenEsineet   ; Sisn: ES:SI, BP, BX, DI
                push    BP DI
                  mov     AL, 87h
                  mov     DI, [SI+BX]   ; raamin osoite
		  call	  PiirrRaami	; BP silyy
                pop     DI BP
                mov     CX, 3 ; rivi
@@Loop:         MOVEZX  AX, [byte @data:BP]
                call    PiirrRaaka     ; DI,BH,CX,DX,BP silyy
                add     DI, 5-14 + 320*(167-166)
                call    PiirrMr
		add	DI, 26-(5+B_MITTA_PIENI_LEVEYS)+320*(166-(167+B_MITTA_PIENI_KORKEUS))
                MOVEZX  AX, [byte @data:BP]
                call    PiirrRaaka
                add     DI, 38-26 + 320*(167-166)
                call    PiirrMr
		add	DI, 14-(38+B_MITTA_PIENI_LEVEYS)+320*(176-(167+B_MITTA_PIENI_KORKEUS))
                loop    @@Loop
                ret
                endp    PiirrYhdenEsineet

        ; alialiohjelma joka piirt 2 numeron luvun.
        ; Sisn: DI=luvun vasen ylnurkka, BP=luvun osoite-1
        ; Ulos: BP=luvun osoite+1, DI=ykksten alla vasemmassa reunassa.
                proc    PiirrMr   near
                inc     BP
                MOVEZX  AX, [byte @data:BP]
                inc     BP
PiirrLuku:	cmp	AX, 99
		mov	BX, 10
		ja	@@Ret	; vltetn lyttmt sekoilut lyttmsti
		div	BL
                push    DS CX
		  mov	  DX, MittariSeg
                  mov     BL, AH ; joten BX=BL=ykkset
                  cbw            ; ja koska AL.7=0 niin AX=AL=kymmenet
                  mov     DS, DX
		  assume  DS:MittariSeg
		  fastimul SI, AX, B_MITTA_PIENI_TAVUJA
		  add	  SI, offset B_Mitta_PieniNum0
                  call    PiirrBkg ; BX,BP silyy, DI=kuvion (numeron) alla
		  add	  DI, B_MITTA_PIENI_LEVEYS - 320*B_MITTA_PIENI_KORKEUS
		  fastimul SI, BX, B_MITTA_PIENI_TAVUJA
		  add	  SI, offset B_Mitta_PieniNum0
                  call    PiirrBkg
                pop     CX DS
                assume  DS:@data
@@Ret:		ret
                endp    PiirrMr

;ͻ
; proc EsineenValinta                                                         
; Valitsee esineen listasta.                                                  
; Sisn: AL = ohjaus (6-9), SI->Valittu[], BP->Esineet[], DI->RaaminOfs[]    
;ͼ
                proc    EsineenValinta  near
                cmp     AL, 10
                jae     @@Ret
                mov     BX, [SI]
                sub     BX, BP  ;BX = esineen paikka 0/2/4/6/8/10
        ; Pyyhitn edellinen raami.
                push    DI AX
                  mov     DI, [BX+DI] ; RaaminOfs[esineen paikka]
                  mov     AL, 2Fh
                  call    PiirrRaami
                pop     AX DI
        ; Valitaan oikeaan suuntaan.
                cmp     AL, 7   ; alas
                jne     @@EiAlas
                add     BX, 2*2
                cmp     BX, 6*2
                jnae    @@Siirretty
                and     BX, 2   ; jtetn vain x-koordinaatti
                jmp     @@Siirretty
@@EiAlas:       cmp     AL, 9   ; yls
                jne     @@EiYls
                sub     BX, 2*2
                jnb     @@Siirretty
                add     BX, 6*2
                jmp     @@Siirretty
@@EiYls:       xor     BX, 2   ; siis sivulle
        ; Piirretn uusi raami.
@@Siirretty:    mov     DI, [BX+DI] ; RaaminOfs[esineen paikka]
                mov     AL, 87h
                call    PiirrRaami
        ; Tallennetaan pointteri.
                add     BX, BP
                mov     [SI], BX
        ; Etsitn kyttrutiini.
                MOVEZX  BX, [BX]
        if @CodeSize ; eli mukana mys seg
         if @Cpu and 08h ;386+
                shl     BX, 2   ; 486: 2  386: 3  286:(5)
         else
                shl     BX, 1   ; 486:(6) 386:(6) 286: 4  086: 4
                shl     BX, 1
         endif
        else  ; vain ofs
                add     BX, BX  ; 486: 1  386: 2  286: 2  086: 3
        endif
                mov     AX, [Kyttrutiinit+BX]
                mov     [SI+(Rutiini0-Valittu0)], AX
@@Ret:          ret
                endp

                proc    PiirrRaami     near ; Sisn: ES:DI, AL
                mov     CX, 11 ; vasen ylnurkka ja 10 ylreunassa
                rep     stosb
                dec     AX    ; tai dec AL... nyt AL=2Eh/86h
                stosb
                mov     CL, 9 ; CH=0. oikea reuna ja alanurkka
                dec     AX    ; tai dec AL... nyt AL=2Dh/85h
@@OikeaLoop:    add     DI, 319
                stosb
                loop    @@OikeaLoop
                dec     DI    ; palataan oikeaan alanurkkaan
                std
                mov     CL, 11 ;CH=0. oikea alanurkka ja alareuna
                rep     stosb
                cld
                inc     AX    ; tai inc AL... nyt AL=2Eh/86h
                stosb         ; vasen alanurkka, nyt ollaan siit oikealle
                inc     AX    ; tai inc AL... nyt AL=2Fh/87h
                mov     CL, 8 ; CH=0. vasen reuna
@@VasenLoop:    sub     DI, 321
                stosb
                loop    @@VasenLoop
                ret
                endp    PiirrRaami     ; Sotkee: DI, CX



                end
