                %title  "Matopas 2: Testipalikat"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "Rnd.mac"

                include "Palikat.inc"
                include "Tiedosto.inc"
                include "Ohjelma.inc"   ; RandSeed
		include "bc_nimet.inc"



KALLE           =       TRUE
OLLI            =       TRUE



                codeseg

;ͻ
; proc LataaRuudulle                                                          
; Lataa paletin ja kuvan ruudulle.                                            
;ͼ
                proc    LataaRuudulle
                lea     DX, [PalettiTiedosto]
                call    AvaaTiedosto
                jc      @@Pois  ; jos virhe
                mov     BX, AX
                push    DS ES
                 pop     DS
                 assume  DS:nothing
                 mov     CX, 256*3
                 mov     DX, 64000      ; Read from File or Device Using Handle
                 mov     AH, 3Fh        ; osoitteeseen DS:DX eli ruudun pern
                 push    DX
                  int     21h
                  mov     DX, 3C8h
                  mov     AL, 0
                 pop     SI
                 out     DX, AL
                 mov     CX, 256*3
                 inc     DX
        if @Cpu and 02h ;80188+
                 rep     outsb
        else
@@Outsb:         lodsb
                 out     DX, AL
                 loop    @@Outsb
        endif
                pop     DS
                assume  DS:@data
                mov     AH, 3Eh         ; Close File Using Handle
                int     21h

                lea     DX, [CaptureTiedosto]
                call    AvaaTiedosto
                jc      @@Pois  ; jos virhe
                mov     BX, AX
                push    DS ES
                 pop     DS
                 assume  DS:nothing
                 mov     CX, 64000
                 mov     AH, 3Fh        ; Read from File or Device Using Handle
                 xor     DX, DX         ; osoitteeseen DS:DX eli A000:0000
                 int     21h
                pop     DS
                mov     AH, 3Eh         ; Close File Using Handle
                int     21h
@@Pois:         ret
                endp    LataaRuudulle

;ͻ
; proc Muunna                                                                 
; Kopioi ruudulta palikat talteen.                                            
;ͼ
; Huom. Tmn rutiinin aikana ES ja DS ovat vrinpin.
                proc    Muunna
                push    DS ES
                  xor     SI, SI
                  lea     DI, [Palikat]
                pop     DS ES
                assume  DS:nothing, ES:@data
                mov     AL, 8   ;           8 rivi,
@@Rivi:         mov     BH, 32  ; kullakin 32 palikkaa,
@@Palikka:      mov     BL, 8   ;  kussakin 8 linjaa,
@@Linja:        mov     CX, 5   ;    joissa 5 wordia eli 2*5=10 pixeli.
                rep     movsw
                add     SI, 320-10      ; siirrytn seuraavan linjan alkuun
                dec     BL
                jnz     @@Linja
                sub     SI, 8*320-10    ; siirrytn seuraavan palikan alkuun
                dec     BH
                jnz     @@Palikka
                add     SI, 8*320-320   ; siirrytn seuraavan rivin alkuun
                dec     AL
                jnz     @@Rivi
                push    ES DS
                pop     ES DS
                assume  DS:@data, ES:nothing
                ret
                endp    Muunna

;ͻ
; proc Kopeloi                                                                
; vesiputousta ett se nytt valuvan.                                       
;ͼ
                proc    Kopeloi
                lea     SI, [Palikat+80*bcVESIPUTOUS]
if OLLI
                mov     AH, 5
else
                mov     AH, 10
endif
@@Pysty:        call    @@Siirra
if OLLI
                dec     SI
                call    @@Siirra
                call    @@Siirra
endif
                dec     AH
                jnz     @@Pysty
if KALLE
                RNDTO   10
                sub     SI, DX
                dec     SI
                call    @@Siirra
endif
                ret
@@Siirra:       mov     AL, [SI+70]
                mov     CX, 8
@@Piste:        xchg    AL, [SI]
                add     SI, 10
                loop    @@Piste
                sub     SI, 80-1
                retn
                endp    Kopeloi



                const

PalettiTiedosto db	"Paletti.raw", 0
CaptureTiedosto db	"Palikat.raw", 0



                udataseg

Palikat         db      256*8*10 dup (?)



                end
