program Raw2Pal;

  const
    Versio = 'Raw2Pal (Matopas 2) 1.1';

  type
    TPaletti = array[Byte] of record R, G, B: Byte end;

  var
    Paletti: TPaletti;

  procedure LueRaw(PalTiedNimi: string);
    var
      RawTied: file of TPaletti;
    begin
      WriteLn('Luen tiedostoa ', RawTiedNimi, ' ...');
      Assign(RawTied, RawTiedNimi);
      Reset(RawTied);
      Read(RawTied, Paletti);
      Close(RawTied)
    end;

  procedure KirjoitaJascPal(JascPalTiedNimi: string);
    function Laajenna_63_255(X: Byte): Byte;
      begin
	Laajenna_63_255 := (X shl 2) or (X shr 4)
      end;
    var
      JascPalTied: Text;
      Vari: Byte;
    begin
      WriteLn('Kirjoitan tiedostoa ', JascPalTiedNimi, ' ...');
      Assign(JascPalTied, JascPalTiedNimi);
      Rewrite(JascPalTied);
      WriteLn(JascPalTied, 'JASC-PAL');
      WriteLn(JascPalTied, '0100');
      WriteLn(JascPalTied, '256');
      for Vari := 0 to 255 do
	with Paletti[Vari] do
	  WriteLn(JascPalTied,
		  Laajenna_63_255(R), ' ',
		  Laajenna_63_255(G), ' ',
		  Laajenna_63_255(B));
      Close(JascPalTied)
    end;

  begin
    WriteLn(Versio);
    if ParamCount <> 1 then begin
      WriteLn('Anna yksi parametri: .raw-tiedoston nimi ilman ptett.');
      Halt(1)
    end;
    LuePal(ParamStr(1)+'.raw');
    KirjoitaJasc(ParamStr(1)+'.pal')
  end

.
