                %title  "Matopas 2: Tallennettava pelitilanne"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"

                include "Matopas2.typ"

                include "Tilanne.inc"
                include "Tiedosto.inc"

		include "Alloc.inc"



		zdataseg	; ihan varmuuden vuoksi!

Muuri1          dw      2*LEVEYS dup (?)
                label   Alkaa   byte
Pelikentt      dw      LEVEYS*KORKEUS dup (?)
Muuri2          dw      2*LEVEYS dup (?)
Vuoro1          db      ?
Vuoro2          db      ?
Vesilaskuri     db      ?
                evendata
Vuoro65535      dw      ?
Kohderutiinit   N_NEAR  128 dup (?)
Kohdeosoitteet  _WORD   128 dup (?)

NapitAlustettu  db      ?       ; jos 0 niin AlustaNapit kopsii Oletusnapit
Pel0Napit       db      5 dup (?)
Pel1Napit       db      5 dup (?)
Valinnat        db      2 dup (?)

                evendata
Pisteet0        dd      ?
Pisteet1        dd      ?
Timantit0       dd      ?
Timantit1       dd      ?
AikaPelaajasta  dw      ?
AikaTimantista  dw      ?
MadonPit0       db      ?
MadonPit1       db      ?
Matoaika0       db      ?
Matoaika1       db      ?
Kiire0          db      ?       ; Eli pitk nppimist lukea
Kiire1          db      ?       ; ensi tilassa. (mato/nopea)
Pelaajia        db      ?

                label   Loppuu  byte

TILANTEEN_KOKO  =       Loppuu-Alkaa



                codeseg

;ͻ
; proc LataaTilanne                                                           
; Lataa pelitilanteen.                                                        
; Sisn: DX -> ASCIIZ tiednimi                                               
;ͼ
                proc    LataaAsetukset
                call    AvaaTiedosto
                jc      @@Latausvirhe
                xchg    BX, AX
                mov     CX, Loppuu-Alkaa
                mov     AH, 3Fh ; read from file
                lea     DX, [Alkaa]
                int     21h
                jc      @@Latausvirhe
                cmp     AX, CX
                jne     @@Latausvirhe
@@Sulje:        mov     AH, 3Eh ; close file
                int     21h
                ret
@@Latausvirhe:  call    @@Sulje
        ; thn vliin "tiedostossa vikaa" tms herjat
                ret
                endp    LataaAsetukset

;ͻ
; proc TallennaTilanne                                                        
; Tallentaa pelitilanteen tiedostoon.                                         
; Sisn: DX -> ASCIIZ nimi                                                   
;ͼ
                proc    TallennaTilanne
                mov     AH, 3Ch ; create file
                mov     CX, 20h ; ready for archiving
                int     21h
                jc      @@Avausvirhe
                xchg    BX, AX
                mov     CX, Loppuu-Alkaa
                mov     AH, 40h ; write into file
                lea     DX, [Alkaa]
                int     21h
                jc      @@TallennVirhe
@@Sulje:        mov     AH, 3Eh ; close file
                int     21h
                ret
@@TallennVirhe: call    @@Sulje
@@Avausvirhe:
        ; tnne herjaa ja paljon
                ret
                endp    TallennaTilanne

;ͻ
; proc VarastoiTilanne                                                        
; Varastoi pelitilanteen muistiin.                                            
; Sisn: DS:DI -> puskuri ja tietysti D=0                                    
;ͼ
                proc    VarastoiTilanne
                push    ES
                 push    DS
                 pop     ES
                 lea     SI, [Alkaa]
                 mov     CX, TILANTEEN_KOKO
                 rep     movsb
                pop     ES
                ret
                endp    VarastoiTilanne

;ͻ
; proc PalautaTilanne                                                         
; Palauttaa pelitilanteen muistista.                                          
; Sisn: DS:SI -> puskuri ja tietysti D=0                                    
;ͼ
                proc    PalautaTilanne
                push    ES
                 push    DS
                 pop     ES
                 lea     DI, [Alkaa]
                 mov     CX, TILANTEEN_KOKO
                 rep     movsb
                pop     ES
                ret
                endp    PalautaTilanne



                end
