                %title  "Matopas 2: TheDraw Uncruncher"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"

                include "Uncrunch.inc"



                codeseg

;ͻ
; proc Uncrunch                                                               
; Tm rutiini tulostaa nyttn TheDrawilla pakatun kuvan. Formaatti:        
;   - koodit 0-31 on varattu listoiminnoille:                                
;     - koodit 0-15 vaihtavat tekstin vri                                   
;     - koodit 16-23 vaihtavat taustan vri                                  
;     - koodi 24 siirtyy seuraavan rivin alkuun                               
;     - koodi 25 tulostaa vlilyntej, mr seuraa                          
;     - koodi 26 tulostaa jotakin muuta, mr ja merkki seuraavat            
;     - koodi 27 vaihtaa vilkkumista plle ja pois                           
;   - koodit 32-255 ovat tulostettavaa teksti                                
; Sisn: DS:SI=osoite, CX=pituus                                             
;ͼ
                proc    Uncrunch
                jcxz    @@Ret
                push    ES
                 mov     DX, 0B800h
                 xor     AX, AX
                 xor     DI, DI
                 mov     ES, DX
                 mov     BX, DI
@@Loop:          lodsb
                 cmp     AL, 32
                 jb      @@Komento
                 stosw                  ; Normaali tulostus     32-255
@@Ohi:           loop    @@Loop
                pop     ES
@@Ret:          ret
@@Komento:       cmp     AL, 16
                 jnb     @@EiAlle16
                 and     AH, 0F0h       ; Tekstin vri          0-15
                 or      AH, AL
                 jmp     @@Ohi
@@EiAlle16:      cmp     AL, 24
                 jnb     @@EiAlle24
                 shl     AL, 4          ; Taustan vri          16-23
                 and     AH, 08Fh
                 or      AH, AL
                 jmp     @@Ohi
@@EiAlle24:      ja      @@Yli24
                 add     BX, 160        ; Seur. rivin alkuun    24
                 mov     DI, BX
                 jmp     @@Ohi
@@Yli24:         cmp     AL, 26
                 jnb     @@EiAlle26
                 lodsb                  ; Vlilyntej          25
                 mov     DL, AL
                 mov     AL, 20h
@@Tulostus:      inc     DL
@@TulostusLoop:  stosw
                 dec     DL
                 jnz     @@TulostusLoop
                 dec     CX
                 jmp     @@Ohi
@@EiAlle26:      ja      @@Yli26
                 lodsb                  ; Muuta                 26
                 mov     DL, AL
                 dec     CX
                 lodsb
                 jmp     @@Tulostus
@@Yli26:         xor     AH, 80h        ; Vilkkuminen           27(-31)
                 jmp     @@Ohi
                endp    Uncrunch



                end
