                %title  "Matopas 2: BKG-kuvien piirto"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "Lot.mac"

                include "Bkg.inc"



                codeseg

;ͻ
; proc PiirrIkkuna                                                           
; Piirt siistin, BKG-kuviolla tytetyn ikkunan.                             
; Sisn: [DS:SI]=taustakuvio, ES=A000, D=0, AXXCX, BXYDX                 
;ͼ
                proc    PiirrIkkuna
        if @Cpu and 02h ;80188+ jolla imul toimii
                imul    DI, BX, 320
        else
                push    BX
                 fastimul DI, BX, 320
                pop     BX
        endif
                add     DI, AX
                PUSHLOT AX BX CX DX DI
                 sub     CX, AX
                 sub     DX, BX          ; DX = korkeus-1
                 mov     BX, CX          ; BX = leveys-1
                 mov     AL, 19
                 rep     stosb           ; ulkoylreuna
                 mov     [byte ES:DI], 22
                 sub     DI, BX
                 add     DI, 321         ; nyt ollaan sisnurkassa ylvasemmalla
                 mov     AL, 24
                 mov     CX, BX
                 dec     CX
                 dec     CX
                 rep     stosb           ; sisylreuna
                 mov     [word ES:DI], 22+256*24
                 mov     CX, DX
                 dec     CX
                 dec     CX
@@OikeaLoop:     add     DI, 320
                 mov     [word ES:DI], 19+256*24
                 loop    @@OikeaLoop     ; pstn sisnurkkaan alavasemmalle
                 mov     CX, BX
                 mov     AL, 19
                 dec     CX
                 std
                 dec     CX
                 rep     stosb           ; sisalareuna
                 add     DI, BX
                 mov     AL, 24
                 add     DI, 319
                 mov     CX, BX
                 rep     stosb           ; ulkoalareuna
                 cld
                 mov     [byte ES:DI], 22; ollaan ulkoalanurkassa
                 sub     DI, 320
                 mov     [word ES:DI], 19+256*22
                 mov     CX, DX
                 dec     CX
                 dec     CX
@@VasenLoop:     sub     DI, 320
                 mov     [word ES:DI], 19+256*24
                 loop    @@VasenLoop
                POPLOT  DI DX CX BX AX
                inc     AX
                dec     DX
                dec     CX
                inc     BX
                inc     AX
                dec     DX
                dec     CX
                inc     BX
                endp    PiirrIkkuna    ; TytBkg pit olla heti perss
;ͻ
; proc TytBkg                                                               
; Tytt halutun alueen BKG-kuviolla.                                        
; Sisn: [DS:SI]=taustakuvio, ES=A000, D=0, AXXCX, BXYDX                 
;ͼ
; Muuttujat:
;       kuvion leveys                   DX
;       piirtolaskuri                   CX
;       kuvion korkeus                  AX
;       kuvion korkeutta jljell       AX mys
;       alueen leveys                   BP
;       alueen leveytt jljell        BP mys
;       alueen korkeutta jljell       BX
;       kohdeosoite                     DI
;       lhdeosoite                     SI
;       lhtpaikka kuviossa            [CS:@@Alku]
;       siirros kuvioiden vlill       [CS:@@Siirros]
                proc    TytBkg
                assume  DS:nothing, ES:nothing
                sub     CX, AX
                sub     DX, BX
                inc     CX      ; nyt CX=alueen leveys
                inc     DX      ;     DX=       korkeus
        ; Alustetaan [@@Alku] ja [@@Siirros].
                push    AX DX
                  lodsw
                  mov     [@@Siirros], AX
                  xor     DX, DX
                  mov     AX, BX  ;yllaita
                  div     [word SI+2] ;kuvion korkeus. AX := ohitettavat.
                  mul     [@@Siirros] ;DX:AX := kokonaissiirros.
                  div     [word SI]   ;kuvion leveys. DX := lopullinen siirros.
                  mov     [@@Alku], DX
                  xor     DX, DX
                  mov     AX, CX  ;alueen leveys
                  div     [word SI] ;kuvion leveys
                  mov     [@@Alku], DX ;jakojnns
                pop     DX AX
        ; Alustetaan DI.
        if @Cpu and 02h ;80188+ jolla imul toimii
                imul    DI, BX, 320
        else
                mov     BP, BX
                fastimul DI, BP, 320  ; BP:n arvo kumminkin kohta hukataan
        endif
                add     DI, AX
        ; Ennen: AX=Vasen, BX=Yl, CX=ALeveys, DX=AKorkeus
                mov     BP, CX
                lodsw
                xchg    BX, AX
                lodsw
        ; Jlkeen: AX=KKorkeus, BX=KLeveys, DX=AKorkeus, BP=ALeveys
@@PatkaLoop:    push    SI AX
@@LinjaLoop:      mov     CX, BX
                  push    BP
                   sub     CX, [@@Alku]
                   add     SI, [@@Alku]
@@JaksoLoop:       sub     BP, CX
                   jbe     @@ViimJakso
                   rep     movsb
                   mov     CX, BX
                   sub     SI, CX
                   jmp     @@JaksoLoop
@@ViimJakso:       add     CX, BP
                   rep     movsb
                   sub     SI, BP  ; negatiivinen
                  pop     BP
                  add     DI, 320
                  sub     DI, BP
                  dec     DX
                  jz      @@Loppui
                  dec     AX
                  jnz     @@LinjaLoop
                  mov     AX, [@@Alku]
                  sub     AX, [@@Siirros]
                  jnb     @@AlkuAX
                  add     AX, BX
@@AlkuAX:         mov     [@@Alku], AX
                pop     AX SI
                jmp     @@PatkaLoop
@@Loppui:       pop     AX SI
                ret
@@Alku          dw      ?
@@Siirros       dw      ?
                endp    TytBkg

;ͻ
; proc PiirrBkg                                                              
; Piirt BKG-kuvion yhden kerran.                                            
; Sisn: [DS:SI]=taustakuvio, [ES:DI]=osoite nytll, D=0                   
; Sotkee: AX, CX, DX, SI=seuraava kuvio, DI=kuvion alla                       
;ͼ
                proc    PiirrBkg
                lodsw           ; siirros
                lodsw           ; leveys
                xchg    DX, AX
                lodsw           ; korkeus
@@Rivi:         mov     CX, DX
                rep     movsb
                sub     DI, DX
                add     DI, 320
                dec     AX
                jnz     @@Rivi
                ret
                endp    PiirrBkg



                end
