                %title  "Matopas 2: Roinien liikkeet"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "Rnd.mac"
                include "MoveZX.mac"
                include "Lot.mac"
                include "Double.mac"

                include "Matopas2.typ"

                include "Liikkeet.inc"
                include "Tilanne.inc"
                include "Piirto.inc"
                include "Napit.inc"
                include "Palikat.inc"
        ;       include "Peli.inc"
                include "Esineet.inc"
                include "Ominais.inc"
                include "Sfx.inc"
                include "Ohjelma.inc"   ; RandSeed

                include "bc_nimet.inc"
                include "cc_nimet.inc"
                include "fx_nimet.inc"

		include "Alloc.inc"

                jumps



                macro   CHECKVUORO1
                cmp     [Vuoro1], 0
                je      Ohita
                endm

                macro   CHECKVUORO2
                cmp     [Vuoro2], 0
                jne     Ohita
                endm

                macro   CHECKVUORO2_ linkki:req
                testflag [Vuoro65535], 1
                jnz     linkki
                endm

                macro   CHECKVUORO4_ linkki:req
                testflag [Vuoro65535], 3
                jnz     linkki
                endm

                macro   FOR     bc:req, rutiini:rest
                org     Hyppytaulukko + 2*bc
                N_NEAR  rutiini
                endm

                macro   CORP    bc:req,  cc:rest
                org     Raatotaulukko + bc
                db      cc
                endm



PIIRR_HAJUT	=	FALSE
TOSI_PAHA       =       TRUE
LEVN_HIDASTUS	=	6	; ei mritelty -> shr
LEVN_ISKU	=	122	; 0..122 (123=norm, 124..127 lent yh)
MADON_AIKA	=	30	; montako vuoroa lyhenemiseen
OHJUSREKURSIO	=	5	; montako askelta ohjus arvioi eteenpin

HAJU_LUU        =       127     ; maksimi
HAJU_RUTTARI    =       116     ; urrh!
HAJU_R_DOOM     =       105     ; sopivasti kypsynyt
HAJU_UKKO       =       90      ; kiintoisampi kuin kuolleena
HAJU_R_MIES     =       60
HAJU_R_ELIN    =       50
HAJU_R_PUURO    =       40
HAJU_R_TOMU     =       20
HAJU_R_PISTEET  =       6



                codeseg

;ͻ
; proc Ohjaa                                                                  
; Lukee ohjaukset.                                                            
;ͼ
                proc    Ohjaa   near
                mov     AL, FALSE
                xchg    AL, [Kiire0]
                or      AL, [Vuoro1]
                jz      @@Ohjaus0OK
                call    LueOhjaus0
                call    @@Tarkista
                mov     [Ohjaus0], AL
@@Ohjaus0OK:    mov     AL, FALSE
                xchg    AL, [Kiire1]
                or      AL, [Vuoro1]
                jz      @@Ohjaus1OK
                call    LueOhjaus1
                call    @@Tarkista
                mov     [Ohjaus1], AL
@@Ohjaus1OK:    ret
@@Tarkista:     cmp     AL, 6
                jb      @@Ret   ; tyhj, ohjaus tai kytt
                cmp     AL, 10
                je      @@Ret   ; pudotus
                mov     AL, 0
@@Ret:          ret
                endp    Ohjaa

;ͻ
; proc Noppa                                                                  
; Sijoittaa pelikentlle halutun mrn haluttuja esineit.                   
; Sisn: BP = merkki, CX = mr                                             
;ͼ
                proc    Noppa
                jcxz    @@Ret
                lea     DI, [Pelikentt]
@@Loop:         RNDTO   LEVEYS*KORKEUS
                DOUBLE  DX
                mov     AX, BP
                mov     BX, DX
                call    Sijoita
                loop    @@Loop
@@Ret:          ret
                endp    Noppa

;ͻ
; proc Tyt                                                                  
; Tytt pelikentn halutulla esineell.                                     
; Sisn: BP = merkki                                                         
;ͼ
                proc    Tyt
                lea     DI, [Pelikentt]
                mov     CX, LEVEYS*KORKEUS
@@Loop:         xor     BX, BX
                mov     AX, BP
                call    Sijoita
                inc     DI
                inc     DI
                loop    @@Loop
                ret
                endp    Tyt

;ͻ
; proc Reunusta                                                               
; Reunustaa pelikentn halutulla esineell.                                   
; Sisn: BP = merkki                                                         
;ͼ
                proc    Reunusta
                lea     DI, [Pelikentt]
                mov     CX, LEVEYS
@@YlAla:       xor     BX, BX
                mov     AX, BP
                call    Sijoita
                mov     BX, LEVEYS*(KORKEUS-1)*2
                mov     AX, BP
                call    Sijoita
                inc     DI
                inc     DI
                loop    @@YlAla
                lea     DI, [Pelikentt]
                mov     CX, KORKEUS
@@VasenOikea:   xor     BX, BX
                mov     AX, BP
                call    Sijoita
                mov     BX, (LEVEYS-1)*2
                mov     AX, BP
                call    Sijoita
                add     DI, LEVEYS*2
                loop    @@VasenOikea
@@Muurit:       push    ES
                 push    DS
                 pop     ES
                 lea     DI, [Muuri1]
                 mov     CX, length Muuri1
                 mov     AX, BP
                 rep     stosw
                 lea     DI, [Muuri2]
                 mov     CX, length Muuri2
                 rep     stosw
                pop     ES
                ret
                endp    Reunusta

;ͻ
; proc Ukko1                                                                  
; Oman ukon liikutus.   (Vasen)                                               
;ͼ
                proc    Ukko1   near
                CHECKVUORO1
                mov     BP, 1 ; pelaajan numero = 1
                MOVEZX  BX, [Ohjaus1]
                jmp     Ukko
                endp    Ukko1

;ͻ
; proc Ukko0                                                                  
; Oman ukon liikutus.   (Oikea)                                               
;ͼ
                proc    Ukko0   near
                CHECKVUORO1
                xor     BP, BP ; pelaajan numero = 0
                MOVEZX  BX, [Ohjaus0]
Ukko:           cmp     [MadonPit0+BP], 0
                jnz     @@Madoksi
                mov     [AikaPelaajasta], 0
                test    BL, BL
                jz      @@Ohitus
                cmp     BL, 5 ;Esineen kytt
                je      @@Kytt
                ja      @@Pudotus
                DOUBLE  BL
                mov     BX, [Suunnat+BX-2]
                mov     AX, [DI+BX]
                push    BX
                 lea     BX, [Ominaisuudet1]
                 xlat           ; AL := [DS:BX+AL] eli [Ominaisuudet1+AL]
                pop     BX
                test    AL, om1ESINE    ; voiko ottaa mukaan? (esineet)
                jnz     @@Esine
                test    AL, om1PISTE    ; voiko kert pisteiksi? (timantti)
                jnz     @@Naminam
                test    AL, om1KULKU    ; pseek lpi? (maa)
                jnz     @@Liiku
@@Tyntk:     test    AL, om1TYNT
                mov     AX, [DI+BX]
                jz      @@Ohitus
                DOUBLE  BX
                cmp     [byte DI+BX], bcILMA
                jne     @@Ohitus
                push    BX
                 call    Fiksusti       ; tynnetn
                pop     BX
                sar     BX, 1
                jmp     @@Liiku
@@Naminam:
        if @Cpu and 08h ;386+
                lea     EBP, [BP]       ; aina nopeampi kuin movzx
                inc     [Pisteet0+EBP*4]
                inc     [Timantit0+EBP*4]
        else
                DOUBLE  BP      ; aina nopeampi kuin shl,2
                DOUBLE  BP
                add     [word low Pisteet0+BP], 1
                adc     [word high Pisteet0+BP], 0
                add     [word low Timantit0+BP], 1
                adc     [word high Timantit0+BP], 0
                shr     BP, 2
        endif
@@Liiku:        mov     AH, [Ohjaus0+BP]
                mov     AL, [DI]
                dec     AH
                sub     AL, [DI+1]
                add     AL, AH
                call    Fiksusti
                xor     BX, BX
                mov     AX, 256*HAJU_UKKO       ; Hajua!
                call    Sijoita
@@Ohitus:       mov     DH, HAJU_UKKO
                jmp     Haise
@@Kytt:       DOUBLE  BP
                mov     SI, [Valittu0+BP]
        if @CodeSize ne 0
                DOUBLE  BP      ; kerrotaankin yhteens neljll (2ofs + 2seg)
        endif
                call    [Rutiini0+BP]
                jmp     @@Ohitus      ;* ent jos veto tms jossa ukko liikkuu?
        if @Cpu and 08h ;386+
@@Esine:        lea     EBP, [BP]
                mov     SI, [Valittu0+EBP*2]
        else ;286-
@@Esine:        DOUBLE  BP
                mov     SI, [Valittu0+BP]
                shr     BP, 1
        endif
                cmp     [word @data:SI], 0
                jnz     @@Tyntk
                mov     AX, [DI+BX]
                mov     [word @data:SI], AX
                PUSHLOT DI CX BX BP
                 call    PiirrEsineet
                POPLOT  BP BX CX DI
                jmp     @@Liiku
@@Pudotus:      MOVEZX  BX, [DI+1]
                DOUBLE  BP
                DOUBLE  BX
                mov     SI, [Valittu0+BP]
                mov     BX, [Suunnat+BX]        ; nyt BX=siirros ukosta
                mov     AX, [SI]
                cmp     [byte DI+BX], 0
                jnz     @@Ohitus        ; jotain edess, ei voi jtt esinett
                push    SI
                 call    Fiksusti
                pop     SI
                mov     [word SI], 0
                push    DI CX
                  call    PiirrEsineet
                pop     CX DI
                jmp     @@Ohitus
@@Madoksi:      mov     AX, BP
                mov     AH, AL          ; ukon numero 0/1
                mov     AL, [DI+1]      ; extrabitit; suunta
                add     AL, bcMATO4
                xor     BX, BX
                call    Sijoita
                jmp     Muikero
                endp    Ukko0

;ͻ
; proc Muikero                                                                
; Mato Muikero. (oma - extrabiteiss pelaajan numero)                         
;ͼ
                proc    Muikero near
                MOVEZX  BX, [DI+1]
                mov     DH, [MadonPit0+BX]      ; DH=madon uusi pituus
                test    DH, DH
                mov     AL, [Ohjaus0+BX] ; AL=ohjaussuunta
                jz      @@Ukoksi
                test    AL, AL
                mov     [AikaPelaajasta], 0
                mov     [Kiire0+BX], TRUE
                jz      @@Ohitus
                cmp     AL, 4
                ja      @@Esine
                mov     BL, AL  ; BH=0... nyt BX=BL=ohjaussuunta
                DOUBLE  BL
                mov     BX, [Suunnat+BX-2]  ; nyt BX = suuntaa vastaava siirros
                MOVEZX  SI, [@data:DI+BX]   ; SI=palikka suunnassa
                test    [Ominaisuudet1+SI], om1ESTE     ; onko este madolle?
                jnz     Ohita
                add     AL, bcMATO4-1   ; ohjauksessa oikealle=1, tss se=+0
                mov     AH, [DI+1]
                push    DX
                 call    Fiksusti        ; siirretn se mato!!
                pop     AX
                mov     AL, bcMATO
                xor     BX, BX
                call    Sijoita         ; hnt pern
@@Ohitus:       jmp     Ohita
@@Esine:        mov     BP, BX
                DOUBLE  BP
                mov     SI, [Valittu0+BP]
        if @CodeSize ne 0
                DOUBLE  BP      ; kerrotaankin yhteens neljll (2ofs + 2seg)
        endif
                call    [Rutiini0+BP]
                jmp     @@Ohitus      ;* ent jos veto tms jossa mato liikkuu?

@@Ukoksi:       mov     AH, [DI]
                sub     AH, bcMATO4     ; suunta
                test    BX, BX
                jz      @@Ukoksi0
                mov     AL, bcPUNAUKKO4
                add     AL, AH
                mov     BX, 0
                call    Sijoita
                jmp     Ukko1
@@Ukoksi0:      mov     AL, bcUKKO4
                add     AL, AH
                mov     BX, 0
                call    Sijoita
                jmp     Ukko0
                endp    Muikero

;ͻ
; proc Ukot                                                                   
; Sijoittaa ukot ylnurkkiin.                                                 
;ͼ
                proc    Ukot
                lea     DI, [Pelikentt]
                mov     BX, 2*(LEVEYS*1+1)
                mov     AX, bcPUNAUKKO4
                call    Sijoita
                mov     BX, 2*(LEVEYS*1+30)
                mov     AX, bcUKKO4+0202h
                call    Sijoita
                ret
                endp    Ukot

;ͻ
; proc Liikuttele                                                             
; Liikuttaa pelikentn esineit hyppimll hyppytaulukon mukaan.              
; Liikutusrutiiniin tultaessa rekistereill on nm arvot:                    
;    DI = liikuteltavan esineen osoite, aina parillinen, l muuta            
;    CX = montako esinett viel liikutettava, l muuta                      
;    ES = 0A000h eli nyttmuistin segmentti Sijoita-rutiinille, l muuta    
;    DS = normaali datasegmentti, l muuta                                   
;    BX = indeksi hyppytaulukkoon, saa kytt                                
;    AX, DX, SI, BP: jotakin roskaa, saa kytt                              
;ͼ
                proc    Liikuttele
                lea     DI, [Pelikentt+LEVEYS*2+2]
                mov     CX, LEVEYS*(KORKEUS-2)-2

                not     [Vuoro1]        ;Laskuri 0-1

                cmp     [Vuoro2],0      ;Laskuri 0-2
                jnz     @@jatkaOHN      ;
                mov     [Vuoro2],3      ;
                not     [Vesilaskuri]   ;...ja Vesilaskuri...
                mov     AL, bcVESI1
                sub     AL, [Vesilaskuri]
                mov     [Vesipalikka], AL
@@jatkaOHN:     dec     [Vuoro2]        ;
                inc     [Vuoro65535]    ;Laskuri 0-65535
                cmp     [Matoaika0], 0                  ; Mato #0?
                je      @@EiMato0
                dec     [Matoaika0]
                jnz     @@EiMato0
                cmp     [MadonPit0], 0
                je      @@EiMato0
                dec     [MadonPit0]
                mov     [Matoaika0], MADON_AIKA
@@EiMato0:      cmp     [Matoaika1], 0                  ; Mato #1?
                je      @@EiMato1
                dec     [Matoaika1]
                jnz     @@EiMato1
                cmp     [MadonPit1], 0
                je      @@EiMato1
                dec     [MadonPit1]
                mov     [Matoaika1], MADON_AIKA
@@EiMato1:
@@Silmukka:     mov     BX, [DI]
                DOUBLE  BX
                jc      @@Seuraavalla
                and     BH, 01h
                jmp     [Hyppytaulukko+BX]
Ohita:
        if @Cpu and 10h
                add     DI, 2
        else
                inc     DI
                inc     DI
        endif
                loop    @@Silmukka
                ret
@@Seuraavalla:
        if @Cpu and 10h                 ; jos 486+:
                and     [byte DI+1], 7Fh
                add     DI, 2
        else                            ; muuten:
                inc     DI
                and     [byte DI], 7Fh
                inc     DI
        endif
                loop    @@Silmukka
                ret
                endp    Liikuttele

;ͻ
; proc Timantti                                                               
; Merkitsee timantiksi ja jatkaa Putoavaan.                                   
;ͼ
                proc    Timantti        near
                mov     [AikaTimantista], 0
                endp    Timantti        ; Putoava pit olla heti perss
;ͻ
; proc Putoava                                                                
; Kohtalaisen yksinkertainen kive tai timanttia liikuttava rutiini.          
;ͼ
                proc    Putoava near
                CHECKVUORO1
                MOVEZX  BX, [byte DI+LEVEYS*2]
                cmp     BL, bcILMA
                je      @@Putoaa
                maskflag [word DI], not bcPUTOAA
                test    [Ominaisuudet2+BX], om2VIERI
                jz      Ohita
                RND     AX
                js      @@Viritys
                mov     AL, [DI+2]              ; vieriik oikealle?
                or      AL, [DI+LEVEYS*2+2]
                jz      @@Oikealle
@@Viritys:      mov     AL, [DI-2]              ; vieriik vasemmalle?
                or      AL, [DI+LEVEYS*2-2]
                jz      @@Vasemmalle
                mov     AL, [DI+2]              ; vieriik oikealle?
                or      AL, [DI+LEVEYS*2+2]
                jnz     Ohita
@@Oikealle:     mov     AX, [DI]        ; kyll vain - siirretn...
                mov     BX, 2
                setflag AX, bcPUTOAA or bcVANHA
                call    Sijoita
                xor     BX, BX          ; ... ja tyhjennetn
                mov     AX, bcILMA
                call    Sijoita
                jmp     Ohita
@@Vasemmalle:   mov     AX, [DI]        ; vieriikin vasemmalle
                mov     BX, -2
                setflag AX, bcPUTOAA    ; ei "or bcVANHA"
                call    Sijoita
                xor     BX, BX
                mov     AX, bcILMA
                call    Sijoita
                jmp     Ohita
@@Putoaa:       mov     AX, [DI]        ; putoaa suoraan alas
                mov     BX, LEVEYS*2
                setflag AX, bcPUTOAA or bcVANHA
                call    Sijoita
                xor     BX, BX
                mov     AX, bcILMA
                call    Sijoita
                jmp     Ohita
                endp    Putoava

;--------------------------------;
;       Junttarin liikutus y+v   ;
;--------------------------------;
proc Junttariyv near
                CHECKVUORO1
                cmp [byte ptr di+1],high bcJUNTY
                jne @@jatkachk1 ;eli jos <> junty
                MOVEZX bx, [byte ptr di-2*LEVEYS]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny     ;kestv esine edess eli knnytn
                mov bx,-64              ;Mennn yls eteenpin
                mov ax,bcJUNTY          ;
                call Sijoita            ;
                xor bx,bx         ;...hnt tilalle
                mov ax,bcKETJUY   ;
                call Sijoita      ;
                jmp Ohita
@@knny:       xor [byte ptr di+1],00000010b   ;knns (kaikki JUNTit kytt)
                jmp Ohita
@@jatkachk1:    cmp [byte ptr di+1],00000010b
                jne @@jatkachk2
                MOVEZX bx, [byte ptr di+2*LEVEYS]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny   ;kestv esine alhaalla takana
                mov bx,64                       ;mennn alas taaksepin
                mov ax,bcJUNTY+1000001000000000b;
                call Sijoita                    ;
                xor bx,bx               ;...tyhj tilalle
                xor ax,ax               ;
                call Sijoita            ;
                jmp Ohita

@@jatkachk2:    cmp[byte ptr di+1], high bcJUNTV
                jne @@jatkachk3 ;eli jos <> junty eteenpin
                MOVEZX bx, [byte ptr di-2]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny       ;kestv esine edess eli knnytn
                mov bx,-2               ;Mennn vasemmalle eteenpin
                mov ax,bcJUNTV          ;
                call Sijoita            ;
                xor bx,bx       ;...hnt tilalle
                mov ax,bcKETJUV ;
                call Sijoita    ;
                jmp Ohita
@@jatkachk3:    MOVEZX bx, [byte ptr di+2]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny     ;kestv esine oikealla takana
                mov bx,2                        ;mennn oikealle taaksepin
                mov ax,bcJUNTV+1000001000000000b;
                call Sijoita                    ;
                xor bx,bx               ;...tyhj tilalle
                xor ax,ax               ;
                call Sijoita            ;
                jmp Ohita
endp Junttariyv

;--------------------------------;
;       Junttarin liikutus a+o   ;
;--------------------------------;
proc Junttariao near
                CHECKVUORO1
                cmp [byte ptr di+1],high bcJUNTA
                jne @@jatkachk1 ;eli jos <> juntA
                MOVEZX bx, [byte ptr di+2*LEVEYS]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny     ;kestv esine edess eli knnytn
                mov bx,64                       ;Mennn alas eteenpin
                mov ax,bcJUNTA+1000000000000000b;
                call Sijoita                    ;
                xor bx,bx         ;...hnt tilalle
                mov ax,bcKETJUA   ;
                call Sijoita      ;
                jmp Ohita
@@knny:       xor [byte ptr di+1],00000010b   ;knns (kaikki JUNTit kytt)
                jmp Ohita
@@jatkachk1:    cmp [byte ptr di+1],00000010b
                jne @@jatkachk2
                MOVEZX bx, [byte ptr di-2*LEVEYS]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny   ;kestv esine ylhll takana
                mov bx,-64                      ;mennn yls taaksepin
                mov ax,bcJUNTA+0000001000000000b;
                call Sijoita                    ;
                xor bx,bx               ;...tyhj tilalle
                xor ax,ax               ;
                call Sijoita            ;
                jmp Ohita

@@jatkachk2:    cmp[byte ptr di+1], high bcJUNTO
                jne @@jatkachk3 ;eli jos <> junty eteenpin
                MOVEZX bx, [byte ptr di+2]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny       ;kestv esine edess eli knnytn
                mov bx,2                        ;Mennn oikealle eteenpin
                mov ax,bcJUNTO+1000000000000000b;
                call Sijoita                    ;
                xor bx,bx       ;...hnt tilalle
                mov ax,bcKETJUO ;
                call Sijoita    ;
                jmp Ohita
@@jatkachk3:    MOVEZX bx, [byte ptr di-2]
                test [Ominaisuudet2 + bx],om2KESTO
                jne @@knny     ;kestv esine vasemmalla takana
                mov bx,-2                       ;mennn vasemmalle taaksepin
                mov ax,bcJUNTO+0000001000000000b;
                call Sijoita                    ;
                xor bx,bx               ;...tyhj tilalle
                xor ax,ax               ;
                call Sijoita            ;
                jmp Ohita
endp Junttariao

;ͻ
; proc VesiKN                                                                 
; Se parempi vesi. Sst 34 rivi eli melkein puolet!                       
;ͼ
                proc    VesiKN  near
                CHECKVUORO2
                MOVEZX  SI, [byte DI+2*LEVEYS]
                mov     AX, [DI]
                test    SI, SI  ; onko alla ilmaa?
                jz      @@Putoaa
                test    [Ominaisuudet2+SI], om2KASTUVA
                jnz     @@Kastelee
@@EiKastele:    test    AH, 01h         ; vasemmalle-lippu
                mov     BX, 2
                jnz     @@Yritys
                neg     BX
@@Yritys:       cmp     [byte DI+BX], bcILMA
                jne     @@Knny
                push    AX BX
                  xor     AX, AX
                  xor     BX, BX
                  call    Sijoita
                pop     BX AX
@@Muodostus:    cmp     [byte DI+BX-2*LEVEYS], bcILMA
                mov     AL, [Vesipalikka]
                je      @@Sijoitus      ; jos pinta vapaa
                add     AL, bcVESIKUOHU1-bcVESI1
                cmp     [byte DI+BX-2*LEVEYS], bcVESIPUTOUS
                je      @@Sijoitus      ; jos kuohuu
                cmp     [byte DI+BX+2*LEVEYS], bcMAA
                mov     AL, bcVESIPOHJA
                je      @@Sijoitus      ; jos alla maata
                mov     AL, bcVESI
@@Sijoitus:     call    Fiksusti
@@Ohitus:       jmp     Ohita
@@Knny:       xor     BX, BX
                xor     AH, 01h        ; kntyy
                jmp     @@Muodostus
@@Putoaa:       push    AX
                 xor     BX, BX
                 xor     AX, AX
                 call    Sijoita
                pop     AX
                mov     BX, 2*LEVEYS
                jmp     @@Muodostus
@@Kastelee:     cmp     [byte DI+2*LEVEYS+1], 123
                jnb     @@EiKastele
                inc     [byte DI+2*LEVEYS+1]
                xor     BX, BX
                xor     AX, AX
                call    Sijoita
                jmp     Ohita
                endp

;-----------------------;
;       Vesiputous      ;
;-----------------------;
proc Vesiputous
;                inc [byte ptr di]
;                cmp [byte ptr di],bcVESIP4+1
;                je @@ykkseksi
@@jatka1:       mov ax, [di]
                mov bx, di
                call Piirr
                cmp [byte ptr di+64],bcILMA
                je @@laitavesi
                jmp Ohita

;@@ykkseksi:    mov [byte ptr di],bcVESIPUTOUS
;                jmp @@jatka1

@@laitavesi:    RND ax
                DOUBLE ah
                jc @@vasemmalle
                mov ax,bcVESI+1000000000000000b
                mov bx,64
                call Sijoita
                jmp Ohita

@@vasemmalle:   mov ax,bcVESI+1000000100000000b
                mov bx,64
                call Sijoita
                jmp Ohita

endp Vesiputous

;ͻ
; proc Tuhoutuu                                                               
; Muuttaa palikan tyhjksi.                                                   
;ͼ
                proc    Tuhoutuu        near
                xor     BX, BX
                xor     AX, AX
                call    Sijoita
                jmp     Ohita
                endp    Tuhoutuu

;ͻ
; proc Raketti                                                                
; Lenntt tavallista violettia rakettia.                                    
;ͼ
                proc    Raketti near
                mov     BX, [DI]
                mov     AX, BX
                sub     BL, bcRAKETTI4
                DOUBLE  BX
                mov     BX, [Suunnat+BX]
                cmp     [byte DI+BX], bcILMA
                jne     Rjyt3x3
                push    AX
                 call    Fiksusti
                pop     AX
                xor     BX, BX
                add     AX, bcLIESKA4-bcRAKETTI4
                call    Sijoita
                jmp     Ohita
Rjyt3x3:     push    CX
                 SFX     fxRJHDYS
                 mov     CX, 3*3
                 lea     BP, [LaajatSuunnat+2*8]
                 mov     [byte DI], CH ;=0 - ilmalla ei ainakaan ole om1POMMI
@@Loop:          mov     BX, [@data:BP]
                 mov     AX, CX
                 add     AX, bcRJHDYS-1
                 call    Rjyt
                 dec     BP
                 dec     BP
                 loop    @@Loop
                pop     CX
                jmp     Ohita
                endp    Raketti

;ͻ
; proc Paineraketti                                                           
; Lenntt punaista paineaaltorakettia.                                      
;ͼ
                proc    Paineraketti    near
                mov     BX, [DI]
                mov     AX, BX
                sub     BL, bcPAINERAK4
                DOUBLE  BX
                mov     BX, [Suunnat+BX]
                cmp     [byte DI+BX], bcILMA
                jne     @@Pam
                push    AX
                 call    Fiksusti
                pop     AX
                xor     BX, BX
                add     AX, bcLIESKA4-bcPAINERAK4
                call    Sijoita
                jmp     Ohita
@@Pam:          push    CX
                 mov     CX, 3*3
                 lea     BP, [LaajatSuunnat+2*8]
                 mov     [byte DI], CH ;=0
@@Loop:          mov     BX, [@data:BP]
                 mov     AX, bcPAINARI
                 call    Rjyt
                 dec     BP
                 dec     BP
                 loop    @@Loop
                pop     CX
                jmp     Ohita
                endp    Paineraketti

;ͻ
; proc Rjhdys                                                               
; Lis palikan arvoon yhdeksn.                                              
;ͼ
                proc    Rjhdys        near
                mov     AX, [DI]
                xor     BX, BX
                add     AL, 9
                call    Sijoita
                jmp     Ohita
                endp    Rjhdys

;ͻ
; proc Paineaalto                                                             
; Levitt itsen ja lis paikalleen yhden.                                 
;ͼ
                proc    Paineaalto      near
                mov     AX, [DI]
                dec     AH
                jz      @@Levitty
                mov     BP, 4*2
@@Loop:         mov     BX, [Suunnat+BP-2]
                cmp     [byte DI+BX], bcILMA
                jne     @@Ohi
                RND     DX
                shr     DH, 1
                cmp     DH, AH
                ja      @@Ohi
                push    AX
                 call    Fiksusti
                pop     AX
@@Ohi:          dec     BP
                dec     BP
                jnz     @@Loop
@@Levitty:      MOVEZX  AX, [byte DI]
                inc     AL
                xor     BX, BX
                call    Sijoita
                jmp     Ohita
                endp    Paineaalto

;ͻ
; proc Lev                                                                   
; Levitt lev (Lev1, Lev2)                                               
;ͼ
                proc    Lev
                mov     AX, [DI]        ;levn muoto talteen
                cmp     AH, 07Bh
                ja      @@lent
                jb      @@Turvalev
                CHECKVUORO2 ; jos lent niin lent tysill
                RND     BX, DX ;dx=temp ;Arpoo, levitnk...
                cmp     BX, [LevnTeho]  ;...
                jnb     @@purluta

@@levi:        RND     BX, DX  ; dx=temp       ;mihin levitn
                rol     BX, 3                   ;
                and     BX, 6                   ;
                mov     BX, [Suunnat+BX]        ;
                MOVEZX  SI, [DI+BX]
                test    [Ominaisuudet2+SI], om2KASVUALA
                jz      @@purluta
                push    AX
                 mov     AL, bcLEV1
                 call    Fiksusti
                 SFX     fxLEV
                pop     AX

@@purluta:      xor     AL,bcLEV1 xor bcLEV2  ;vaihtaa levn ulkomuotoa
@@thn:        xor     BX,BX                   ;
                call    Sijoita                 ;
                jmp     Ohita
@@lent:
        if @Cpu and 08h ;386+
                movzx   EBX, AH
                mov     BX, [Suunnat+(EBX-7Ch)*2]
        else
                xor     BX, BX
                mov     BL, AH
                DOUBLE  BX
                mov     BX, [Suunnat+BX-2*07Ch]
        endif
                xor     AL, bcLEV1 xor bcLEV2 ; purlutetaan matkalla
                cmp     [byte DI+BX], bcILMA
                jne     @@osui
                call    Fiksusti
                xor     AX, AX
                jmp     @@thn ; pyyhitn entinen pois

@@Turvalev:    ;CHECKVUORO2 jos halutaan hitaampi levtursoke
                RND     BX, DX ;dx=temp ;Arpoo, levitnk...
        ifdef LEVN_HIDASTUS
                sub     AH, LEVN_HIDASTUS
                jnb     @@ei_pakkasella
                xor     AH, AH
                jmp     Ohita ; ei en levit
@@ei_pakkasella:
        else
                shr     AH, 1
        endif
                sub     BH, AH
                jb      @@levi
                sub     BH, AH
                jb      @@levi
                jmp     Ohita   ; tai @@purluta
@@osui:         mov     AH, LEVN_ISKU
                jmp     @@thn ; muututaan tursivaksi levkasvannaiseksi
                endp    Lev

;ͻ
; proc Palo2                                                                  
; Lis palikan arvoon kaksi.                                                 
;ͼ
                proc    Palo2   near
                inc     [byte DI+1]
                endp    Palo2   ; Palo pit olla heti perss
;ͻ
; proc Palo                                                                   
; Lis palikan arvoon yhden.                                                 
;ͼ
                proc    Palo    near
                mov     AX, [DI]
                xor     BX, BX
                inc     AL
                call    Sijoita
                jmp     Ohita
                endp    Palo

;ͻ
; proc Roihupalo                                                              
; Lis palikan arvoon yhden, jos extrabittej, niin toimii roihuna.          
;ͼ
                proc    Roihupalo near
                mov     AX, [DI]
                inc     AL

                MOVEZX  BX, AH
                test    BL, BL
                jne     @@onroihu       ;jos on extrabittej...

                call    Sijoita
                jmp     Ohita

@@onroihu:      push    BX
                 push    AX
                  RNDTO   3
                  DOUBLE  BX
                  add     BX, DX
                  DOUBLE  BX
                 pop     AX ; ei osoiteta BX:ll heti
                 mov     BX, [Suunnat8+BX-6]
                 MOVEZX  SI, [DI+BX]
                 test    [Ominaisuudet2+SI], om2KESTO
                 jz      @@eieste
                pop     BX
                shl     BX, 2          ;jos on este, yritetn suoraan
                mov     BX, [Suunnat8+BX-4]
                MOVEZX  SI, [DI+BX]
                test    [Ominaisuudet2+SI], om2KESTO
                jnz     @@hnt
                 call    Fiksusti
                jmp     @@hnt

@@eieste:        call    Fiksusti
                pop     BX
@@hnt:        xor     BX, BX
                xor     AH, AH
                call    Sijoita
                jmp     Ohita
                endp    Roihupalo

;ͻ
; proc Viemri                                                                
; Imee nestett.                                                              
;ͼ
                proc    Viemri near
                MOVEZX  BX, [byte DI-2*LEVEYS]
                test    [Ominaisuudet2+BX], om2NESTE
                jnz     @@Kaappaa
@@Nollaus:      and     [byte DI+1], not 1
@@Ohitus:       jmp     Ohita
@@Kaappaa:      test    [byte DI+1], 1
                jnz     @@Ime
                or      [byte DI+1], 1
                setflag [word DI-2*LEVEYS], bcVANHA
                jmp     @@Ohitus
@@Ime:          mov     BX, -2*LEVEYS
                xor     AX, AX
                call    Sijoita
                jmp     @@Nollaus
                endp    Viemri

;ͻ
; proc Aikapommi                                                              
; Rjht ajan kuluttua loppuun. Sammuu vedell.                             
;ͼ
                proc    Aikapommi       near
                MOVEZX  BX, [DI-2*LEVEYS]
                test    [Ominaisuudet2+BX], om2NESTE
                jnz     @@Sammuu
                dec     [byte DI+1]
                jnz     @@Ohitus
                mov     AL, [DI]
                inc     AL
                mov     AH, 15
                cmp     AL, bcPOMMIPALO+10
                je      Rjyt3x3
@@Muuta:        xor     BX, BX
                call    Sijoita
@@Ohitus:       jmp     Ohita
@@Sammuu:       mov     AX, bcPOMMI
                jmp     @@Muuta
                endp    Aikapommi

;ͻ
; proc Haju                                                                   
; Levitt hajua ilmassa.                                                     
;ͼ
                proc    Haju    near
                test    [Nappulat+ktiBACKSPACE], ktbALHAALLA
                jnz     @@Ohitus
                mov     DX, [DI]
                sub     DH, 1
                jc      @@Ohitus
                mov     [DI], DX
        if PIIRR_HAJUT
                mov     BX, DI
                call    PiirrHaju      ; DH (& BP) silyy
        endif
                sub     DH, 1
                jc      @@Ohitus
Haise:          mov     BP, 8
@@Loop:         mov     BX, [Suunnat+BP-2]
                dec     BP
                mov     AX, [DI+BX]
                test    AL, AL
                jnz     @@Seuraava
                and     AH, 7Fh
                cmp     AH, DH
                jae     @@Seuraava
                mov     [DI+BX+1], DH
                test    BH, 80h
                jnz     @@JoTakana
                or      [byte DI+BX+1], 80h
@@JoTakana:
        if PIIRR_HAJUT
                add     BX, DI
                call    PiirrHaju  ; BP (& DH) silyy
        endif
@@Seuraava:     dec     BP
                jnz     @@Loop
@@Ohitus:       jmp     Ohita
                endp    Haju

        if PIIRR_HAJUT
                proc    PiirrHaju      near
                sub     BX, offset Pelikentt  ; BX: 00000YYY YYXXXXX0
                shl     BX, 2                  ; BX: 000YYYYY XXXXX000
                push    DI
                 shr     BL, 3                 ; BX: 000YYYYY 000XXXXX
                 mov     AL, DH
                 fastimul DI, BX, 10           ; 10*(X+256*Y) = 10*X+8*320*Y
                 mov     AH, DH          ;;;;;;;;;;
                 add     DI, 2 + 2*320   ;;;;;;;;;;
                 mov     BX, 4           ;;DhDhDh;;
@@Loop:          stosw                   ;;DhDhDh;;
                 stosw                   ;;DhDhDh;;
                 stosw                   ;;DhDhDh;;
                 add     DI, -6+320      ;;;;;;;;;;
                 dec     BX              ;;;;;;;;;;
                 jnz     @@Loop
                pop     DI
                ret
                endp    PiirrHaju
        endif

;ͻ
; proc Rakki                                                                  
; Seuraa hajua ilmassa.                                                       
;ͼ
                proc    Rakki   near
                CHECKVUORO2_ @@Ohitus
                MOVEZX  BX, [byte DI]
                push    CX
                 mov     CX, 4
                 sub     BL, bcRAKKI4
                 xor     AH, AH
                 DOUBLE  BX
                 xor     SI, SI
@@Loop:          mov     BP, [Suunnat+BX+SI]
                 cmp     [byte @data:DI+BP], 0
                 jne     @@Seuraava
                 mov     AL, [@data:DI+BP+1]
                 and     AL, 7Fh
                 cmp     AL, AH
                 jna     @@Seuraava
                 mov     AH, AL
                 mov     DX, SI
@@Seuraava:      inc     SI
                 inc     SI
                 loop    @@Loop
                pop     CX
                test    AH, AH
                jnz     @@TllHaisee
        ; Ilmeisesti ei haise.
                mov     SI, BX
                mov     BX, [Suunnat+BX]
                cmp     [byte DI+BX], 0
                je      @@Kulje
                RNDTO   10
                cmp     DL, 1
                ja      Ohita
                mov     BX, SI
                je      @@Oikealle      ; cmp...
                mov     DX, 6
                jmp     @@EiTakana
        ; Nyt DX=hyv knns, 0/2/4/6
@@TllHaisee: test    DX, DX
                jz      @@Suoraan
                cmp     DX, 4   ; takana -> knnytnkin oikealle
                jne     @@EiTakana
@@Oikealle:     mov     DX, 2   ; oikealla
@@EiTakana:     add     BX, DX
                shr     BX, 1
                mov     AX, bcRAKKI4
                and     BL, 3
                add     AL, BL
                xor     BX, BX
                call    Sijoita
                jmp     @@Ohitus
@@Suoraan:      mov     SI, DX
                mov     BX, [Suunnat+BX+SI]
                cmp     [byte DI+BX], 0
                jne     @@Ohitus
@@Kulje:        mov     AX, [DI]
                call    Fiksusti
                xor     AX, AX
                xor     BX, BX
                call    Sijoita
@@Ohitus:       jmp     Ohita
                endp    Rakki

;ͻ
; proc RndOrg                                                                 
; Liikuttelee rndorgia tysin satunnaisesti.                                  
;ͼ
                proc    RndOrg  near
                RND     BX
                mov     AX, [DI]
                rol     BX, 3
                inc     AX
                and     BX, 0006h
                cmp     AL, bcRNDORG+3
                mov     BX, [Suunnat+BX]
                jb      @@AnimOK
                mov     AL, bcRNDORG
@@AnimOK:       cmp     [byte DI+BX], 0
                je      @@SuuntaOK
@@Tss:        xor     BX, BX          ; Pysytn tss.
                call    Sijoita
@@Ohitus:       jmp     Ohita
@@SuuntaOK:     call    Fiksusti
                mov     AX, bcRNDORGJLKI
                jmp     @@Tss
                endp    RndOrg

;ͻ
; proc Ruuti                                                                  
; Syttyy herksti.                                                            
;ͼ
                proc    Ruuti   near
                mov     SI, 4*2
@@Loop:         mov     BX, [Suunnat+SI-2]
                MOVEZX  BX, [byte DI+BX]
                test    [Ominaisuudet1+BX], om1PALO
                jnz     @@Syttyy
                dec     SI
                dec     SI
                jnz     @@Loop
@@Pudotus:      jmp     Putoava
@@Syttyy:       mov     AX, bcRUUTIPALO
                xor     BX, BX
                call    Sijoita
                jmp     @@Pudotus
                endp    Ruuti

;ͻ
; proc Ruttari                                                                
; Snt ympri.                                                              
;ͼ
                proc    Ruttari near
                CHECKVUORO1
                RND     BX
                rol     BX, 3
                and     BX, 0006h
                mov     AX, [DI]
                mov     BX, [Suunnat+BX]
                MOVEZX  SI, [DI+BX]
                test    [Ominaisuudet1+SI], om1KULKU
                jz      @@EiPse
                call    Fiksusti
                mov     AX, 256*HAJU_RUTTARI    ; Hajua!!!
                xor     BX, BX
                call    Sijoita
@@Haisu:        mov     DH, HAJU_RUTTARI
                jmp     Haise
@@EiPse:      test    [Ominaisuudet3+SI], om3OMA
                jz      @@Haisu
        ; Tartutetaan ukkoon rutto.
                call    Fiksusti        ; siirretn rutto vaan ei pyyhit
                jmp     @@Haisu
                endp    Ruttari

;-----------------------;
;     Laser oikealle    ;
;-----------------------;
proc Lasero
                mov bx,2
                mov bp,bcLASERJLKIVO
                jmp laserliike
endp Lasero

;-----------------------;
;       Laser alas      ;
;-----------------------;
proc Lasera
                mov bx,64
                mov bp,bcLASERJLKIYA
                jmp laserliike
endp Lasera

;-----------------------;
;    Laser vasemmalle   ;
;-----------------------;
proc Laserv
                mov bx,-2
                mov bp,bcLASERJLKIVO
                jmp laserliike
endp Laserv

;-----------------------;
;       Laser yls      ;
;-----------------------;
proc Lasery
                mov bx,-64
                mov bp,bcLASERJLKIYA
laserliike:     cmp [byte ptr di+bx],bcILMA
                je @@liiku
                mov ax,bcPLY
                call Rjyt
                jmp @@jalkea
@@liiku:        mov ax,[di]
                call Fiksusti
@@jalkea:       xor bx,bx
                mov ax,bp
                call Sijoita
                jmp Ohita
endp Lasery

;----------------------;
;     Leviv tiili    ;
;----------------------;
proc Leviv
                CHECKVUORO1
                mov bx,-2
                cmp [byte ptr di+bx],bcILMA
                je @@levia
@@jatka1:       mov bx,2
                cmp [byte ptr di+bx],bcILMA
                jne Ohita
@@levia:        mov ax,bcLEVIV
                call Fiksusti
                jmp @@jatka1
endp Leviv

;ͻ
; proc Riske                                                                 
; Riskyv roina / rndorgjlki, tulee tykinkuulasta.                          
;ͼ
                proc    Riske  near
                mov     AL, [byte DI+1]
                DOUBLE  AL
                jz      Palo
                cmp     AL, 2*8
                ja      Palo
                MOVEZX  BX, AL
                mov     BX, [Suunnat8+BX-2]
                MOVEZX  SI, [DI+BX]
                test    [Ominaisuudet2+SI], om2HARVA
                jz      Rjyt3x3
                mov     AX, [DI]
                call    Fiksusti
                jmp     Palo
                endp    Riske

;ͻ
; proc Tykinammus                                                             
; Osuessaan rjht kylven tuhoa ja kuolemaa ymprilleen.                   
;ͼ
                proc    Tykinammus
                mov     BX, [DI]
                mov     AX, BX
        if TOSI_PAHA
                xor     BH, BH  ; poistetaan kauhubitit
        endif
                DOUBLE  BX
                mov     BX, [Suunnat - 2*bcTYKINAMMUS4 + BX]
                MOVEZX  SI, [DI+BX]
                test    [Ominaisuudet2+SI], om2HARVA
                jnz     @@Liiku
                neg     BX
                push    CX BX
        if TOSI_PAHA
                  test    AH, AH
                  jz      @@Lopullinen
                  push    DI
                   sub     AX, bcTYKINAMMUS4 + 256
                   xor     AL, 2  ; taakse
                   DOUBLE  BX
                   mov     CH, AL                        ; CH = suunta taakse,
                   lea     BP, [Suunnat + 3*2]
                   inc     CH                            ; 1=oikealle
                   mov     AL, bcTYKINAMMUS4+3
                   mov     CL, 4
@@PahaLoop:        mov     BX, [@data:BP]
                   cmp     CL, CH
                   je      @@Takana
                   push    AX SI
                    call    Rjyt ; CX&BP silyy
                   pop     SI AX
@@Takana:          dec     BP
                   dec     AX ; oikeastaan vain AL
                   dec     BP
                   dec     CL
                   jnz     @@PahaLoop
                pop     DI BX CX
                mov     [word DI], bcRJHTV
                jmp     Ohita
@@Lopullinen:
        endif
                  mov     CX, 3*3
                  lea     BP, [LaajatSuunnat+2*8]
                  mov     [byte DI], CH ;=0 - ilmalla ei ainakaan ole om1POMMI
@@Loop:           mov     BX, [@data:BP]
                  mov     AX, [@data:Riskeet-LaajatSuunnat+BP]
                  call    Rjyt
                  dec     BP
                  dec     BP
                  loop    @@Loop
                pop     BX CX
                and     [byte DI+BX+1], bcVANHA shr 8
                jmp     Ohita
@@Liiku:        call    Fiksusti
                xor     BX, BX
                mov     AX, bcPLY
                call    Sijoita
                jmp     Ohita
                endp    Tykinammus

                proc    Raadoksi        near
                MOVEZX  BX, [byte DI+1]
                DOUBLE  BX
                mov     AX, [Raatotyypit+BX]
                xor     BX, BX
                call    Sijoita
                jmp     Ohita
                endp    Raadoksi

                proc    Rjhtv       near
                jmp     Rjyt3x3 ;*
                endp

                proc    Ohjus   near
        ; SI = 2*extrabitit
        ; AX =   kohderutiini
        ; BX =   kohdeosoite
        ; DI = 2*palikka kohdeosoitteessa
                push    DI
                 MOVEZX  SI, [DI+1]
		 DOUBLE  SI
                 mov     BX, [Kohdeosoitteet+SI]
                 mov     AX, [Kohderutiinit+SI]
                 call    @@Kokeile
                 add     BX, 2                  ; oikealle
                 call    @@Kokeile
                 add     BX, -2 +2*LEVEYS       ; alas
                 call    @@Kokeile
                 add     BX, -2*LEVEYS -2       ; vasemmalle
                 call    @@Kokeile
                 add     BX, +2 -2*LEVEYS       ; yls
                 call    @@Kokeile
                pop     DI
	; Koska oikeaa kohdetta ei lydy, lennetn suoraan eteenpin.
@@Suoraan:	mov	AX, [DI]
		MOVEZX	BX, AL
		sub	BL, bcOHJUS8
		DOUBLE	BX
		mov	BX, [Suunnat8+BX]
		cmp	[byte DI+BX], 0
		jz	@@Lenn
		jmp	Rjyt3x3	; Tie tukossa
@@Kokeile:        MOVEZX  DI, [BX]
                  DOUBLE  DI
                  cmp     [Hyppytaulukko+DI], AX
                  je      @@Lytyi
                 retn
@@Lytyi:        pop     AX     ; poistetaan paluuosoite pinosta
                 mov     [Kohdeosoitteet+SI], BX
                pop     DI
        ; BX = uusi kohdeosoite
                mov     SI, BX
                sub     BX, offset Pelikentt   ; BX: 00000YYY YYXXXXX0
        if (@Cpu and 0Ch) eq 04h ;80286
                add     BX, BX          ; 8086:(6) 286: 4  386:(4) 486:(2)
                add     BX, BX
        else ;muut
                shl     BX, 2           ; 8086: 4  286:(7) 386: 3  486: 2
        endif ;80286/muut                       ; BX: 000YYYYY XXXXX00
                mov     AX, BX
                mov     BX, DI
        if @Cpu and 08h ;386+
                shr     AL, 3
        else ;286-
                shr     AL, 1
        endif ;386+/286-
        ; BX = ohjuksen osoite
                sub     BX, offset Pelikentt   ; BX: 00000YYY YYXXXXX0
        if (@Cpu and 0Ch) eq 04h ;80286
                add     BX, BX          ; 8086:(6) 286: 4  386:(4) 486:(2)
                add     BX, BX
        else ;muut
                shl     BX, 2           ; 8086: 4  286:(7) 386: 3  486: 2
        endif ;80286/muut                       ; BX: 000YYYYY XXXXX000
        if @Cpu and 08h ;386+
                shr     BL, 3
        else ;286-
                shr     BL, 1
        endif ;386+/286-
                sub     AL, BL          ; AL = 4*KohdeX - 4*OhjusX
                sub     AH, BH          ; AH = KohdeY - OhjusY
        if (@Cpu and 08h) eq 0 ;286-
                sar     AL, 2           ; AL = KohdeX - OhjusX
        endif
                cmp     AL, +1
                jg      @@Kaukana
                cmp     AL, -1
                jl      @@Kaukana
                cmp     AH, +1
                jg      @@Kaukana
                cmp     AH, -1
                jnl     Rjyt3x3      ; kohde on vieress
        ; Sitten selvitetn miten ohjus tnn liikkuu.
@@Kaukana:      MOVEZX  BX, [DI]
                push    CX
                 sub     BL, bcOHJUS8    ; BL = suunta 0..7, BH=0
		 DOUBLE  BX
		 mov	 DX, BX
        ; Rekisterit tss: AL = KohdeX-OhjusX
        ;                   AH = KohdeY-OhjusY
        ;                   SI = kohteen osoite
	;		    BX = 2*suunta 0..7, BH=0
		 jmp	 [Ohjusrutiinit+BX]
Ohjus_O:	 cmp	 AH, BH  ;BH=0. AH=KohdeY-OhjusY
                 jz      @@Eteen         ; jos KohdeY = OhjusY
                 jl      @@Vasemmalle    ; jos KohdeY < OhjusY
                 jmp     @@Oikealle      ; jos KohdeY > OhjusY
Ohjus_AO:        cmp     AL, AH  ; AL=KohdeX-OhjusX, AH=KohdeY-OhjusY
                 jz      @@Eteen         ; jos KohdeX-OhjusX = KohdeY-OhjusY
                 jl      @@Oikealle      ; jos KohdeX-OhjusX < KohdeY-OhjusY
                 jmp     @@Vasemmalle    ; jos KohdeX-OhjusX > KohdeY-OhjusY
Ohjus_A:	 cmp	 AL, BH  ;BH=0. AL=KohdeX-OhjusX
                 jz      @@Eteen         ; jos KohdeX = OhjusX
                 jl      @@Oikealle      ; jos KohdeX < OhjusX
                 jmp     @@Vasemmalle    ; jos KohdeX > OhjusX
Ohjus_AV:        neg     AH      ; AH=KohdeY-OhjusY
                 cmp     AL, AH  ; AL=KohdeX-OhjusX, AH=OhjusY-KohdeY
                 jz      @@Eteen         ; jos KohdeX-OhjusX = OhjusY-KohdeY
                 jl      @@Oikealle      ; jos KohdeX-OhjusX < OhjusY-KohdeY
                 jmp     @@Vasemmalle    ; jos KohdeX-OhjusX > OhjusY-KohdeY
Ohjus_V:	 cmp	 AH, BH  ;BH=0. AH=KohdeY-OhjusY
                 jz      @@Eteen         ; jos KohdeY = OhjusY
                 jl      @@Oikealle      ; jos KohdeY < OhjusY
                 jmp     @@Vasemmalle    ; jos KohdeY > OhjusY
Ohjus_YV:        cmp     AL, AH  ; AL=KohdeX-OhjusX, AH=KohdeY-OhjusY
                 jz      @@Eteen         ; jos KohdeX-OhjusX = KohdeY-OhjusY
                 jl      @@Vasemmalle    ; jos KohdeX-OhjusX < KohdeY-OhjusY
                 jmp     @@Oikealle      ; jos KohdeX-OhjusX > KohdeY-OhjusY
Ohjus_Y:	 cmp	 AL, BH  ;BH=0. AL=KohdeX-OhjusX
                 jz      @@Eteen         ; jos KohdeX = OhjusX
                 jl      @@Vasemmalle    ; jos KohdeX < OhjusX
                 jmp     @@Oikealle      ; jos KohdeX > OhjusX
Ohjus_YO:        neg     AH      ; AH=KohdeY-OhjusY
                 cmp     AL, AH  ; AL=KohdeX-OhjusX, AH=OhjusY-KohdeY
                 jz      @@Eteen         ; jos KohdeX-OhjusX = OhjusY-KohdeY
                 jl      @@Vasemmalle    ; jos KohdeX-OhjusX < OhjusY-KohdeY
                 jmp     @@Oikealle      ; jos KohdeX-OhjusX > OhjusY-KohdeY
@@Vasemmalle:	 sub	 BX, 2
		 call	 @@AloitaYritys
		 add	 BX, 2
		 call	 @@AloitaYritys
		 add	 BX, 2
		 call	 @@AloitaYritys
		pop	CX
		jmp	@@Suoraan	; tekoly petti
@@Oikealle:	 add	 BX, 2
		 call	 @@AloitaYritys
		 sub	 BX, 2
		 call	 @@AloitaYritys
		 sub	 BX, 2
		 call	 @@AloitaYritys
		pop	CX
		jmp	@@Suoraan	; tekoly petti
@@Eteen:	 call	 @@AloitaYritys
		 sub	 BX, 2
		 call	 @@AloitaYritys
		 add	 BX, 4
		 call	 @@AloitaYritys
		pop	CX
		jmp	@@Suoraan
	; Sisn:
	;   DI =   ohjuksen oletettu osoite
	;   BX = 2*ohjuksen oletettu suunta
	;   SI =   kohdeosoite
	; Ulos (jos eponnistui):
	;   AX, CX, BP sekaisin
                proc    @@AloitaYritys  near
                push    DI BX
                  mov     BP, SP
                  mov     CX, OHJUSREKURSIO
		  call	  @@YritAskelia
		pop	BX DI
		ret
	; Sisn:
	;   DI =   ohjuksen oletettu osoite
	;   BX = 2*ohjuksen oletettu suunta
	;   SI =   kohdeosoite
	;   CX =   vhenev rekursiolaskuri
	;   BP =   SP ennen rekursiota
	; Ulos (jos eponnistui):
	;   AX, BX sekaisin
                proc    @@YritAskelia  near
        ; Ensin tutkitaan, pstnk yhtn askelta.
@@Rekursio:	mov	AX, [Suunnat8+BX]
		push	DI
		 add	 DI, AX
		 cmp	 DI, SI ; kohdeosoite?
		 je	 @@Kelpaa
		 cmp	 [byte DI], bcILMA
		 jne	 @@Palaa
	; Pstn yksi askel. Pstnk enemmn?
		 dec	 CX
		 jz	 @@Kelpaa	; jos rekursioraja tuli vastaan
		 call	 @@Rekursio
		 sub	 BX, 2	; kokeillaan knty vasemmalle
		 call	 @@Rekursio
		 add	 BX, 4	; ents oikealle
		 call	 @@Rekursio
		 sub	 BX, 2	; ei sitten
		 inc	 CX
@@Palaa:	pop	DI
		ret
@@Kelpaa:
		endp   ;@@YritAskelia
		  mov	 SP, BP ; hvitetn rekursiopino
		pop	BX DI
		add	SP, 2	; hvitetn paluuosoite
		endp   ;@@AloitaYritys
	; Ratkaisu lytyi!
		pop	CX
		and	BX, 000Eh
		mov	AH, [DI+1]
		mov	AL, BL
		shr	AL, 1
                add     AL, bcOHJUS8
		mov	BX, [Suunnat8+BX]
@@Lenn:	call	Fiksusti
                mov     AX, bcPLY
                xor     BX, BX
                call    Sijoita
                jmp     Ohita
                endp    Ohjus

                proc    MadonHnt      near
                dec     [byte DI+1]
                jnz     Ohita
                xor     AX, AX
                xor     BX, BX
                call    Sijoita
                jmp     Ohita
                endp    MadonHnt

;ͻ
; proc Rnkttilinen							       
; Kntyy mielelln vasemmalle.					       
;ͼ
                proc    Rnkttilinen  near
		CHECKVUORO1
		mov	AL, [byte DI+1]
		dec	AL
		and	AX, 0003h
		DOUBLE	AX
		mov	SI, AX
		mov	BX, [Suunnat+SI]
		cmp	[byte DI+BX], bcILMA
		je	@@Siirry
		add	SI, 2
		mov	BX, [Suunnat+SI]
		cmp	[byte DI+BX], bcILMA
		je	@@Siirry
		add	SI, 2
		mov	BX, 0
@@Siirry:	mov	AX, SI
		and	AX, 0006h
		shl	AX, 7
		mov	AL, [DI]
		push	BX
		 call	 Fiksusti
		pop	BX
		test	BX, BX
		jz	@@Paikallaan
		xor	AX, AX
		xor	BX, BX
		call	Sijoita
@@Paikallaan:	jmp	Ohita
		endp	Rnkttilinen

                proc    Luu     near
                mov     DH, HAJU_LUU
                jmp     Haise
                endp    Luu

                proc    RaatoDoom       near
                mov     DH, HAJU_R_DOOM
                jmp     Haise
                endp    RaatoDoom

                proc    RaatoPuuro      near
                mov     DH, HAJU_R_PUURO
                jmp     Haise
                endp    RaatoPuuro

                proc    RaatoTomu       near
                mov     DH, HAJU_R_TOMU
                jmp     Haise
                endp    RaatoTomu

                proc    RaatoPisteet    near
                mov     DH, HAJU_R_PISTEET
                jmp     Haise
                endp    RaatoPisteet

                proc    RaatoElin      near
                mov     DH, HAJU_R_ELIN
                jmp     Haise
                endp    RaatoElin

                proc    RaatoMies       near
                mov     DH, HAJU_R_MIES
                jmp     Haise
                endp    RaatoMies



                const

Ohjusrutiinit   N_NEAR  Ohjus_O, Ohjus_AO, Ohjus_A, Ohjus_AV, \
                        Ohjus_V, Ohjus_YV, Ohjus_Y, Ohjus_YO

                dw      0
Suunnat         dw      2*4 dup (?)
                org     Suunnat
                dw      2 dup (2, 2*LEVEYS, -2, -2*LEVEYS)

LaajatSuunnat   dw      -2*LEVEYS-2, -2*LEVEYS, -2*LEVEYS+2
                dw               -2,         0,           2
                dw       2*LEVEYS-2,  2*LEVEYS,  2*LEVEYS+2

	; Tll on rutkasti tilaa ylivuodoille.
		dw	2, 2 + 2*LEVEYS, 2*LEVEYS,-2 + 2*LEVEYS
                dw      -2, -2 - 2*LEVEYS, -2*LEVEYS, 2 - 2*LEVEYS
Suunnat8	dw	2, 2 + 2*LEVEYS, 2*LEVEYS,-2 + 2*LEVEYS
                dw      -2, -2 - 2*LEVEYS, -2*LEVEYS, 2 - 2*LEVEYS
		dw	2, 2 + 2*LEVEYS, 2*LEVEYS,-2 + 2*LEVEYS
                dw      -2, -2 - 2*LEVEYS, -2*LEVEYS, 2 - 2*LEVEYS

Riskeet        dw      bcRNDORGJLKI+256*6, \
                        bcRNDORGJLKI+256*7, \
                        bcRNDORGJLKI+256*8
                dw      bcRNDORGJLKI+256*5, \
                        bcRNDORGJLKI+256*0, \
                        bcRNDORGJLKI+256*1
                dw      bcRNDORGJLKI+256*4, \
                        bcRNDORGJLKI+256*3, \
                        bcRNDORGJLKI+256*2

Raatotyypit     dw      0, bcRAATODOOM, bcRAATOPUURO, bcRAATOTOMU, \
                           bcRAATOPISTEET, bcRAATOELIN, bcRAATOMIES



                dataseg

LevnTeho       dw      8000     ;/65536

Hyppytaulukko   N_NEAR  256 dup (Ohita)
                FOR     bcILMA,         Haju
                FOR     bcRNDORG,       3 dup (RndOrg)
		FOR	bcMATO4,	4 dup (Muikero)
                FOR     bcUKKO4,        4 dup (Ukko0)
                FOR     bcPUNAUKKO4,    4 dup (Ukko1)
		FOR	bcRNKK,	Rnkttilinen
		FOR	bcRUTTARI,	Ruttari
                FOR     bcLEV1,        2 dup (Lev)
                FOR     bcMATO,         MadonHnt
                FOR     bcRAKKI4,       4 dup (Rakki)
                FOR     bcRUUTI,        Ruuti
                FOR     bcTIMANTTI,     Timantti
                FOR     bcKIVI,         Putoava
                FOR     bcLEVIV,      Leviv
		FOR	bcLEHV,	Viemri
		FOR	bcLEHVYV,	Viemri
		FOR	bcLEHVYO,	Viemri
		FOR	bcLEHVAV,	Viemri
		FOR	bcLEHVAO,	Viemri
                FOR     <low bcJUNTA>,  Junttariao, Junttariyv
		FOR	bcPUU,		Viemri
		FOR	bcPAKSUPUU,	3 dup (Viemri)
                FOR     bcVESIPUTOUS,   Vesiputous
                FOR     bcLUU,          Luu
                FOR     bcVESIKUOHU1,   2 dup (VesiKN)
		FOR	bcVESI, 	VesiKN
		FOR	bcVESI1,	VesiKN
		FOR	bcVESI2,	VesiKN
		FOR	bcVESIPOHJA,	VesiKN
                FOR     bcRAATODOOM,    RaatoDoom
                FOR     bcRAATOPUURO,   RaatoPuuro
                FOR     bcRAATOTOMU,    RaatoTomu
                FOR     bcRAATOPISTEET, RaatoPisteet
                FOR     bcRAATOELIN,   RaatoElin
                FOR     bcRAATOMIES,    RaatoMies
                FOR     bcPOMMIPALO,    10 dup (Aikapommi)
                FOR     bcRAKETTI4,     4 dup (Raketti)
                FOR     bcPAINERAK4,    4 dup (Paineraketti)
                FOR     bcLIESKA4,      4 dup (Tuhoutuu)
                FOR     bcTYKINAMMUS4,  4 dup (Tykinammus)
                FOR     bcOHJUS8,       8 dup (Ohjus)
                FOR     bcLASER4,       Lasero, Lasera, Laserv, Lasery
                FOR     bcLASERJLKIVO, 3 dup (Palo), Tuhoutuu
                FOR     bcLASERJLKIYA, 3 dup (Palo), Tuhoutuu
                FOR     bcRNDORGJLKI,  Riske, Palo, Tuhoutuu
                FOR     bcPLY,         5 dup (Palo), Raadoksi
                FOR     bcRUUTIPALO,    4 dup (Palo), Palo2
                FOR     bcPAINARI,      Paineaalto
                FOR     bcPALO,         15 dup (Roihupalo), Tuhoutuu
                FOR     bcRJHDYS,     5*9 dup (Rjhdys), \
                                        3+1 dup (Rjhdys), Tuhoutuu, 1+3 dup (Rjhdys), \
                                        3+1 dup (Tuhoutuu), Rjhtv, 1+3 dup (Tuhoutuu)

                org     Hyppytaulukko+2*256

Raatotaulukko   db      256 dup (0)
                CORP    bcUKKO4,        4 dup (ccMIES)
                CORP    bcPETO4,        4 dup (ccELIN)
                CORP    bcMATO,         ccDOOM
                CORP    bcMATO4,        4 dup (ccPUURO)
                CORP    bcRNDORG,       3 dup (ccPISTEET)
                CORP    bcRAKKI4,       4 dup (ccELIN)
                CORP    bcRUTTARI,      ccMIES
                CORP    bcTULIMIES,     ccMIES
                CORP    bcRAATODOOM,    ccPUURO
                CORP    bcRAATOPUURO,   ccTOMU
                CORP    bcRAATOTOMU,    ccPISTEET
                CORP    bcRAATOPISTEET, ccPISTEET
                CORP    bcRAATOELIN,   ccDOOM
                CORP    bcRAATOMIES,    ccDOOM
                CORP    bcPUNAUKKO4,    4 dup (ccMIES)



		zdataseg

Vesipalikka     db      ?



		udataseg

Ohjaus0 	db	?
Ohjaus1         db      ?



                end
