program Mpd2Bkg;

  var
    Kuva: array[0..199, 0..319] of Byte;

  procedure LueMpd(MpdNimi: string);
    var
      MpdTied: file;
    begin
      WriteLn('Luen tiedostoa ', MpdNimi, ' ...');
      Assign(MpdTied, MpdNimi);
      Reset(MpdTied, 1);
      if FileSize(MpdTied) <> 64000 then begin
        WriteLn('Tiedosto on vrn kokoinen (', FileSize(MpdTied),
                '), pitisi olla 64000.');
        Close(MpdTied);
        Halt(1)
      end;
      BlockRead(MpdTied, Kuva, SizeOf(Kuva));
      Close(MpdTied)
    end;

  procedure KirjoitaBkg(BkgNimi: string);
    var
      BkgTied: file;
      Vasen, Oikea, Leveys, Korkeus, Siirros, Y, Huippu, Pohja, Alin: Word;
    begin
      WriteLn('Kirjoitan tiedostoa ', BkgNimi, ' ...');
      Assign(BkgTied, BkgNimi);
      Rewrite(BkgTied, 1);
      WriteLn('Siirros':10, 'Leveys':10, 'Korkeus':10, 'Offset':10);
      Huippu := 0;
      Alin := 0;
      while (Huippu < 199) and (Kuva[Huippu, 0] <> 15) do begin
        Vasen := 0;
        while (Vasen < 320) and (Kuva[Huippu, Vasen] <> 15) do begin
          Oikea := Vasen;
          while (Oikea < 320) and (Kuva[Huippu, Oikea] <> 15) do
            Inc(Oikea);
          if (Oikea > 319) and (Vasen > 0) then begin
            WriteLn;
            WriteLn('Lohko jatkuu oikeaan reunaan asti vaikka ei ala vasemmasta!');
            WriteLn('Jos kyseess ei ole virhe, siirr lohko alemmas vasempaan reunaan.');
            Close(BkgTied);
            Halt(2)
          end;
          Pohja := Huippu;
          while (Pohja < 200) and (Kuva[Pohja, Vasen] <> 15) do
            Inc(Pohja);
          if Pohja > Alin then
            Alin := Pohja;
          Siirros := 0;
          while Kuva[Pohja, Oikea-1-Siirros] <> 15 do
            Inc(Siirros);
          Leveys := Oikea - Vasen;
          Korkeus := Pohja - Huippu;
          WriteLn(Siirros:10, Leveys:10, Korkeus:10, FilePos(BkgTied):10);
          BlockWrite(BkgTied, Siirros, SizeOf(Siirros));
          BlockWrite(BkgTied, Leveys, SizeOf(Leveys));
          BlockWrite(BkgTied, Korkeus, SizeOf(Korkeus));
          for Y := Huippu to Pohja-1 do
            BlockWrite(BkgTied, Kuva[Y, Vasen], Leveys);
          Vasen := Oikea + 1
        end;
        Huippu := Alin + 1
      end;
      WriteLn;
      WriteLn('Valmis. Tiedoston koko on ', FileSize(BkgTied), '.');
      Close(BkgTied)
    end;

  begin
    WriteLn('Mpd2Bkg v1.3');
    if ParamCount <> 1 then begin
      WriteLn('Anna yksi parametri: .mpd-tiedoston nimi ilman ptett.');
      Halt(1)
    end;
    LueMpd(ParamStr(1)+'.mpd');
    KirjoitaBkg(ParamStr(1)+'.bkg')
  end

.
