                %title  "Matopas 2: Testipohjelma"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "Seg.mac"
                include "MoveZX.mac"

                include "Ohjelma.inc"
                include "Liikkeet.inc"
                include "Piirto.inc"
                include "Palikat.inc"
                include "Napit.inc"
                include "Uncrunch.inc"
                include "Editori.inc"
                include "Fontit.inc"
                include "Peli.inc"
                include "Alku.inc"
                include "Asetus.inc"
                include "Nollaus.inc"
                include "Tiedosto.inc"
                include "Kello.inc"
                include "JakoYli.inc"
                include "Temple.inc"

                include "bc_nimet.inc"

                include "Paniikki.seg"

		include "Alloc.inc"



                extrn   CRUNCHED_END: byte
                extrn   CRUNCHED_END_LENGTH: word
                extrn   CRUNCHED_END_DEPTH: word



                codeseg

;ͻ
; proc Alusta                                                                 
; Huolehtii ohjelman aloituksesta ja lopetuksesta, kutsuu _mainia.            
;ͼ
                proc    Alusta
		mov	AX, [DS:002Ch]	; Env
		mov	DX, @data
		mov	DS, DX
		mov	[EnvSeg], AX
		mov	[PSPSeg], ES

		mov	AH, 30h 	; Tarkistetaan DOS 3+
                int     21h
		cmp	AL, 2
		ja	@@DOS3
		pushf
		 mov	 AH, 09h	 ; Pahoitellaan
		 lea	 DX, [AlleDOS3Viesti]
		 int	 21h
		popf
		je	@@DOS2
		xor	AX, AX		; Hivytn (DOS 1.x)
		push	[PSPSeg] AX
		retf
@@DOS2: 	exitcode 02h		; Hivytn (DOS 2.x)

@@DOS3: 	mov	AX, 1A00h	; Tarkistetaan VGA
                int     10h     ; jos on, BL on nyt 7 tai 8...
                sub     BL, 7                 ; nyt 0 tai 1...
                shr     BL, 1                 ; ja nyt 0 - muulloin ei.
                jz      @@VGA
                mov     AH, 09h         ; Pahoitellaan
                lea     DX, [AlleVGAViesti]
                int     21h
		exitcode 03h		; Hivytn

@@VGA:		xor	AX, AX		; Nollataan hiiri
                mov     ES, AX
                les     BX, [ES:4*33h]
                mov     CX, ES
                or      CX, BX
                jz      @@EiHiirt
                int     33h ;AX=0
                inc     AX
                jz      @@Hiiri
@@EiHiirt:     mov     AH, 09h
                lea     DX, [EiHiirtViesti]
                int     21h
                exitcode 04h

@@Hiiri:        mov     AH, 2Ch
                int     21h
                xor     [RandSeed], CX
                xor     [RandSeed], DX
        ; Tutkitaan Extended Keyboard BIOS.
                mov     AX, 0555h       ; pistetn 0FFFFh nppis-
                mov     CX, 0FFFFh      ; puskuriin. jos ei bios
                int     16h             ; tunne niin j AL=55h=??
                test    AL, 0FEh        ; oikeat paluuarvot ovat
                jnz     @@VanhaKeyBios  ; 0=success ja 1=full
                test    AL, AL
                jnz     @@UusiKeyBios   ; hyptn jos tysi
                mov     CX, 16  ; kokeillaan 16 kertaa
@@KeyBiosLoop:  mov     AH, 10h ; lukea nppispuskurista
                int     16h
                inc     AX
                jz      @@UusiKeyBios   ; koska lytyi 0FFFFh
                loop    @@KeyBiosLoop
@@VanhaKeyBios: mov     [Int16_AH_maski], not 10h
@@UusiKeyBios:  
        ; Nollataan BSS.
                push    DS              
                 cld
                pop     ES
		lea	CX, [HlsC_ZDataEnd]
		lea	DI, [HlsC_ZDataBegin]
                mov     AX, 0A000h      ; AL=0 nollaukseen
                sub     CX, DI
                rep     stosb  ; AX ei muutu
                mov     ES, AX
        ; Koko loppuohjelman ajan pit olla D=0 ja ES=A000.
        ; Jos joku rutiini muuttaa niin palauttakoon itse!

        ; Kielletn keskeytykset jottei ^C voi hirit ennen omien nppis-
        ; rutiinien asennusta. Jos se on painettu jo ennen tt niin DOS
        ; keskeytt ohjelman AlkuViestin tulostuksen aikana ja kaikki on
        ; hyvin. Omiin nppisrutiineihin (Napit.asm) kuuluu Int1B-handleri,
        ; joka ei tee yhtn mitn. Normaalisti se asettaisi DOSin lipun joka
        ; pysyttisi ohjelman seuraavassa DOS-kutsussa, jolloin kaikki vekto-
        ; rit jisivt palauttamatta ja kone sekoaisi pian. Mutta kun keskey-
        ; tykset kielletn tss ja palautetaan vasta 1B-handlerin asennuksen
        ; jlkeen, kaikki nppimisttapahtumat joutuvat omalle rutiinille,
        ; jonka avulla ne ksitelln itse tysin ntisti ja ilman tilttej.
                cli     ; lue ylt miksi.
                lea     DX, [AlkuViesti]
                mov     AH, 09h
                int     21h
                call    AvaaNapit
                sti     ; nyt nppis saa kertoa asiansa
                call    AvaaKello
                call    AvaaJakoYli
                call    _main           ; Kutsutaan pohjelmaa
                call    SuljeJakoYli
                call    SuljeKello
                call    SuljeNapit
                mov     AX, 0003h       ; Palautetaan tekstitila
                int     10h
	if 1
		lea	DX, [LoppuViesti]
		mov	AH, 09h
		int	21h
	else
                lea     SI, [CRUNCHED_END]
                mov     CX, [CRUNCHED_END_LENGTH]
                call    Uncrunch
                mov     AH, 2           ; Siirretn kursori
                xor     BH, BH
                mov     DH, [byte CRUNCHED_END_DEPTH]
                xor     DL, DL
                int     10h
	endif
                exitcode 00h            ; Hivytn
                endp    Alusta

;ͻ
; proc HetiPois                                                               
; Lopettaa ohjelman heti mahdollisimman siististi.                            
;ͼ
                proc    HetiPois
                push    AX
                 SETUPDS
                 call    SuljeKello      ; Lopetetaan keskeytysrutiinit
                 call    SuljeNapit
                 call    SuljeJakoYli
                 mov     AX, 0003h       ; Palautetaan tekstitila
                 int     10h
                pop     BX
                MOVSEG  DS, PaniikkiSeg
                assume  DS:PaniikkiSeg
                cmp     [word BX], "NK" ; tss ovat eripin kuin muistissa
                jne     @@Exit
                lea     DX, [BX+3]
                MOVEZX  SI, [BX+2]
                cmp     [byte BX+SI], "$"
                jne     @@Exit
                cmp     [word BX+SI-2], 13 + 10*256
                jne     @@Exit
                mov     AH, 09h ; tulostetaan
                int     21h
@@Exit:         exitcode 0FFh           ; Hivytn
                endp

                assume  DS:@data
;ͻ
; proc _main                                                                  
; Pohjelma. Lhinn kokeilee eri toimintoja.                                
;ͼ
                proc    _main
                call    AlustaTiedosto
                call    LataaAsetukset
                call    AlustaPeli
                call    Alku
                call    Graph13h
                push    ES
                 mov     ES, [PSPSeg]
                 cmp     [word ES:81h], 'f '
                pop     ES
                je      @@Templeen
                call    LataaRuudulle
                call    Muunna
                call    AlustaPehmennys
                call    AlustaEditori
                test    [Nappulat+ktiPAUSE], ktbPAINETTU
                jz      @@Jatkuu
                and     [Nappulat+ktiPAUSE], not ktbPAINETTU
@@Alkupause:    test    [Nappulat+ktiPAUSE], ktbPAINETTU
                jz      @@Alkupause
                and     [Nappulat+ktiPAUSE], not ktbPAINETTU
@@Jatkuu:       call    LataaFontit
                xor     AX, AX
                int     33h
                mov     BP, bcMAA       ; kentt
                call    Tyt
                call    Ukot            ; ukot
                mov     BP, bcKESTO     ; seint
                call    Reunusta
                call    PiirrKaikki
		call	Editoi
                ret
@@Templeen:     call    TempleMain
                ret
                endp    _main



                const

AlkuViesti	db	"Matopas 2 (C) 1994-1996 Olli ja Kalle Niemitalo", 13, 10, "$"
;AlkuViesti	 db	 "Tmn kehitysversion kopiointi on ehdottomasti ", \
;			 "kielletty.", 13, 10
;		 db	 "Ainoastaan Olli ja Kalle Niemitalo, Jukka Holappa, ", \
;			 "Eino Oja ja Lasse rni", 13, 10
;		 db	 "saavat pit hallussaan ja pelata tt versiota", 13, 10
;		 db	 "- muut (including YOU, Shalafi!) odottakoot julkaisua.", 13, 10, "$"
AlleVGAViesti	db	"Valitettavasti tarvitset vhintn VGA-nytn ", \
			"nhdksesi upean grafiikan.", 13, 10, "$"
AlleDOS3Viesti	db	"Taidat olla hieman ajasta jljess. ", \
			"Nykyn kytetn jo DOS-versiota 7.0,", 13, 10
		db	"tosin tlle pelille riittisi kolmonenkin.", 13, 10, "$"
EiHiirtViesti	db	"Sik kissa hiiresi, vai unohtuiko driveri?", 13, 10, "$"
LoppuViesti	db	"Tm kehitysversio on laitettu sorsineen levitykseen, koska emme jaksaneet", 13, 10
		db	"kirjoittaa sit loppuun. Saat pelata, kopioida ja muutella sit KOPIOI.TXT:ss", 13, 10
		db	"olevien sntjen mukaisesti.", 13, 10
		db	13, 10
		db	"Kallelta <tosi@stekt.oulu.fi> terveisi basso-Dominukselle, rin-Faustille,", 13,10
		db	"Buckralle, 2003-Shalafille, MITSHM-Saarelle ja aika-Tuomolle.", 13, 10
		db	"Ja mikseip myskin Yeharille, Ayelle, Samulille, Hannalle ja Paavolle.", 13, 10
		db	"$"



                udataseg

RandSeed	dw	?
EnvSeg          dw      ?       ; nm asetetaan ennen nollausta
PSPSeg          dw      ?       ; joten ei parane en nollata



		zdataseg

		label	HlsC_ZDataBegin



		stack



		end	Alusta
